############ TCL FILE ######################################
# USER AND DATE STAMP
############################################################

  set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]


  if { ![info exists mom_sys_post_initialized] } {

     source ${cam_post_dir}ugpost_base.tcl

     proc MOM_before_each_add_var {} {}
     proc MOM_before_each_event {} {}

     set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]
     source ${cam_debug_dir}mom_review.tcl
     MOM_set_debug_mode OFF


   ####  Listing File variables
     set mom_sys_list_output                       "OFF"
     set mom_sys_header_output                     "OFF"
     set mom_sys_list_file_rows                    "40"
     set mom_sys_list_file_columns                 "30"
     set mom_sys_warning_output                    "OFF"
     set mom_sys_group_output                      "ON"
     set mom_sys_list_file_suffix                  "lpt"
     set mom_sys_output_file_suffix                "eia"
     set mom_sys_commentary_output                 "ON"
     set mom_sys_commentary_list                   "x y z 4axis 5axis feed speed"

     set mom_sys_control_out                       "("
     set mom_sys_control_in                        ")"

     set mom_sys_post_initialized 1
  }


########## SYSTEM VARIABLE DECLARATIONS ##############
  set mom_sys_rapid_code                        "0"
  set mom_sys_linear_code                       "1"
  set mom_sys_circle_code(CLW)                  "2"
  set mom_sys_circle_code(CCLW)                 "3"
  set mom_sys_delay_code(SECONDS)               "4"
  set mom_sys_delay_code(REVOLUTIONS)           "4"
  set mom_sys_cutcom_plane_code(XY)             "17"
  set mom_sys_cutcom_plane_code(ZX)             "18"
  set mom_sys_cutcom_plane_code(YZ)             "19"
  set mom_sys_cutcom_code(OFF)                  "40"
  set mom_sys_cutcom_code(LEFT)                 "41"
  set mom_sys_cutcom_code(RIGHT)                "42"
  set mom_sys_adjust_code                       "43"
  set mom_sys_adjust_code_minus                 "44"
  set mom_sys_adjust_cancel_code                "49"
  set mom_sys_unit_code(IN)                     "20"
  set mom_sys_unit_code(MM)                     "21"
  set mom_sys_cycle_start_code                  "79"
  set mom_sys_cycle_off                         "80"
  set mom_sys_cycle_drill_code                  "81"
  set mom_sys_cycle_drill_dwell_code            "82"
  set mom_sys_cycle_drill_deep_code             "83"
  set mom_sys_cycle_drill_break_chip_code       "73"
  set mom_sys_cycle_tap_code                    "84"
  set mom_sys_cycle_bore_code                   "85"
  set mom_sys_cycle_bore_drag_code              "86"
  set mom_sys_cycle_bore_no_drag_code           "76"
  set mom_sys_cycle_bore_dwell_code             "89"
  set mom_sys_cycle_bore_manual_code            "88"
  set mom_sys_cycle_bore_back_code              "87"
  set mom_sys_cycle_bore_manual_dwell_code      "89"
  set mom_sys_cycle_tap_with_chuck_code         "63"
  set mom_sys_cycle_tap_without_chuck_code      "331"
  set mom_sys_output_code(ABSOLUTE)             "90"
  set mom_sys_output_code(INCREMENTAL)          "91"
  set mom_sys_cycle_ret_code(AUTO)              "98"
  set mom_sys_cycle_ret_code(MANUAL)            "99"
  set mom_sys_reset_code                        "53.5"
  set mom_sys_feed_rate_mode_code(IPM)          "98"
  set mom_sys_feed_rate_mode_code(IPR)          "99"
  set mom_sys_feed_rate_mode_code(FRN)          "93"
  set mom_sys_spindle_mode_code(SFM)            "96"
  set mom_sys_spindle_mode_code(RPM)            "97"
  set mom_sys_return_code                       "28"
  set mom_sys_feed_rate_mode_code(DPM)          "94"
  set mom_sys_program_stop_code                 "0"
  set mom_sys_optional_stop_code                "1"
  set mom_sys_end_of_program_code               "17"
  set mom_sys_spindle_direction_code(CLW)       "203"
  set mom_sys_spindle_direction_code(CCLW)      "204"
  set mom_sys_spindle_direction_code(OFF)       "205"
  set mom_sys_tool_change_code                  "999"
  set mom_sys_coolant_code(ON)                  "8"
  set mom_sys_coolant_code(FLOOD)               "8"
  set mom_sys_coolant_code(MIST)                "7"
  set mom_sys_coolant_code(THRU)                "26"
  set mom_sys_coolant_code(TAP)                 "8"
  set mom_sys_coolant_code(OFF)                 "9"
  set mom_sys_rewind_code                       "30"
  set mom_sys_sim_cycle_drill                   "0"
  set mom_sys_sim_cycle_drill_dwell             "0"
  set mom_sys_sim_cycle_drill_deep              "0"
  set mom_sys_sim_cycle_drill_break_chip        "0"
  set mom_sys_sim_cycle_tap                     "0"
  set mom_sys_sim_cycle_bore                    "0"
  set mom_sys_sim_cycle_bore_drag               "0"
  set mom_sys_sim_cycle_bore_nodrag             "0"
  set mom_sys_sim_cycle_bore_manual             "0"
  set mom_sys_sim_cycle_bore_dwell              "0"
  set mom_sys_sim_cycle_bore_manual_dwell       "0"
  set mom_sys_sim_cycle_bore_back               "0"
#  set mom_sys_cir_vector                        "Vector - Arc Center to Start"
  set mom_sys_cir_vector                        "Vector - Arc Start to Center"
  set mom_sys_spindle_ranges                    "0"
  set mom_sys_rewind_stop_code                  "\#"
  set mom_sys_home_pos(0)                       "0"
  set mom_sys_home_pos(1)                       "-5"
  set mom_sys_home_pos(2)                       "10"
  set mom_sys_zero                              "0"
  set mom_sys_opskip_block_leader               "/"
  set mom_sys_seqnum_start                      "10"
  set mom_sys_seqnum_incr                       "10"
  set mom_sys_seqnum_freq                       "1"
  set mom_sys_seqnum_max                        "9999"
  set mom_sys_leader(N)                         "N"
  set mom_sys_leader(X)                         "X"
  set mom_sys_leader(Y)                         "Y"
  set mom_sys_leader(Z)                         "Z"
  set mom_sys_leader(fourth_axis)               "B"
  set mom_sys_leader(fifth_axis)                "C"
  set mom_sys_contour_feed_mode(LINEAR)         "IPM"
  set mom_sys_rapid_feed_mode(LINEAR)           "IPM"
  set mom_sys_cycle_feed_mode                   "IPM"
  set mom_sys_feed_param(IPM,format)            "Feed_IPM"
  set mom_sys_feed_param(IPR,format)            "Feed_IPR"
  set mom_sys_feed_param(FRN,format)            "Feed_INV"
  set mom_sys_vnc_rapid_dogleg                  "1"
  set mom_sys_prev_mach_head                    ""
  set mom_sys_curr_mach_head                    ""
  set mom_sys_contour_feed_mode(ROTARY)         "IPM"
  set mom_sys_contour_feed_mode(LINEAR_ROTARY)  "IPM"
  set mom_sys_rapid_feed_mode(ROTARY)           "IPM"
  set mom_sys_rapid_feed_mode(LINEAR_ROTARY)    "IPM"
  set mom_sys_feed_param(DPM,format)            "Feed_DPM"
  set mom_sys_lathe_x_double                    "1"
  set mom_sys_lathe_i_double                    "1"
  set mom_sys_lathe_x_factor                    "1"
  set mom_sys_lathe_z_factor                    "1"


####### KINEMATIC VARIABLE DECLARATIONS ##############
  set mom_kin_4th_axis_ang_offset               "0.0"
  set mom_kin_4th_axis_center_offset(0)         "0"
  set mom_kin_4th_axis_center_offset(1)         "0"
  set mom_kin_4th_axis_center_offset(2)         "0"
  set mom_kin_4th_axis_direction                "MAGNITUDE_DETERMINES_DIRECTION"
  set mom_kin_4th_axis_incr_switch              "OFF"
  set mom_kin_4th_axis_leader                   "B"
  set mom_kin_4th_axis_limit_action             "Warning"
  set mom_kin_4th_axis_max_limit                "210"
  set mom_kin_4th_axis_min_incr                 "0.001"
  set mom_kin_4th_axis_min_limit                "-30"
  set mom_kin_4th_axis_plane                    "ZX"
  set mom_kin_4th_axis_rotation                 "standard"
  set mom_kin_4th_axis_type                     "Head"
  set mom_kin_4th_axis_zero                     "0.0"
  set mom_kin_5th_axis_ang_offset               "0.0"
  set mom_kin_5th_axis_center_offset(0)         "0.0"
  set mom_kin_5th_axis_center_offset(1)         "0.0"
  set mom_kin_5th_axis_center_offset(2)         "0.0"
  set mom_kin_5th_axis_direction                "MAGNITUDE_DETERMINES_DIRECTION"
  set mom_kin_5th_axis_incr_switch              "OFF"
  set mom_kin_5th_axis_leader                   "C"
  set mom_kin_5th_axis_limit_action             "Warning"
  set mom_kin_5th_axis_max_limit                "360"
  set mom_kin_5th_axis_min_incr                 "0.001"
  set mom_kin_5th_axis_min_limit                "-360"
  set mom_kin_5th_axis_plane                    "XY"
  set mom_kin_5th_axis_rotation                 "standard"
  set mom_kin_5th_axis_type                     "Table"
  set mom_kin_5th_axis_zero                     "0.0"
  set mom_kin_arc_output_mode                   "FULL_CIRCLE"
  set mom_kin_arc_valid_plane                   "XYZ"
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_flush_time                        "2.0"
  set mom_kin_linearization_flag                "TRUE"
  set mom_kin_linearization_tol                 "0.03"
  set mom_kin_machine_resolution                ".001"
  set mom_kin_machine_type                      "5_axis_head_table"
  set mom_kin_max_arc_radius                    "9999.9999"
  set mom_kin_max_dpm                           "100"
  set mom_kin_max_fpm                           "600"
  set mom_kin_max_fpr                           "100"
  set mom_kin_max_frn                           "99999.999"
  set mom_kin_min_arc_length                    "0.001"
  set mom_kin_min_arc_radius                    "0.001"
  set mom_kin_min_dpm                           "0.0"
  set mom_kin_min_fpm                           "0.1"
  set mom_kin_min_fpr                           "0.01"
  set mom_kin_min_frn                           "0.001"
  set mom_kin_output_unit                       "MM"
  set mom_kin_pivot_gauge_offset                "0.0"
  set mom_kin_pivot_guage_offset                ""
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "4000"
  set mom_kin_tool_change_time                  ""
  set mom_kin_x_axis_limit                      "485"
  set mom_kin_y_axis_limit                      "80"
  set mom_kin_z_axis_limit                      "1070"
 set mom_kin_read_ahead_next_motion            "ON"
###################
# IS&V Enhancement
###################
   set kl_path    0
   set kl_polar   0
   set prev_out_angle_pos(0) 0
   set prev_out_angle_pos(1) 0
if { ![info exists sim_mtd_initialized] } {
   set sim_mtd_initialized 0
}

set mom_sim_vnc_handler [file rootname [info script]]_vnc.tcl


#=============================================================
proc MOM_SIM_initialize_mtd {} {
#=============================================================
  global sim_mtd_initialized

   SIM_mtd_init NC_CONTROLLER_MTD_EVENT_HANDLER

   uplevel #0 {
      source "$mom_sim_vnc_handler"
   }

   set sim_mtd_initialized 1
}


#++++++++++++++++++++++++++++++++++++++++++
# Source & initialize VNC for a child post
#++++++++++++++++++++++++++++++++++++++++++
if { $sim_mtd_initialized == 1 } {
  source "$mom_sim_vnc_handler"
  if [llength [info commands PB_VNC_init_sim_vars] ] {
    PB_VNC_init_sim_vars
  }
}




#=============================================================
proc MOM_start_of_program { } {
#=============================================================
  global mom_logname mom_date is_from  mom_sys_group_output
  global mom_coolant_status mom_cutcom_status
  global mom_clamp_status mom_cycle_status
  global mom_spindle_status mom_cutcom_plane pb_start_of_program_flag
  global mom_cutcom_adjust_register mom_tool_adjust_register
  global mom_tool_length_adjust_register mom_length_comp_register
  global mom_flush_register mom_wire_cutcom_adjust_register
  global mom_wire_cutcom_status

    set pb_start_of_program_flag 0
    set mom_coolant_status UNDEFINED
    set mom_cutcom_status  UNDEFINED
    set mom_clamp_status   UNDEFINED
    set mom_cycle_status   UNDEFINED
    set mom_spindle_status UNDEFINED
    set mom_cutcom_plane   UNDEFINED
    set mom_wire_cutcom_status  UNDEFINED

    catch {unset mom_cutcom_adjust_register}
    catch {unset mom_tool_adjust_register}
    catch {unset mom_tool_length_adjust_register}
    catch {unset mom_length_comp_register}
    catch {unset mom_flush_register}
    catch {unset mom_wire_cutcom_adjust_register}

    set is_from ""

    OPEN_files ; #open warning and listing files
    LIST_FILE_HEADER ; #list header in commentary listing



  global mom_sys_post_initialized
  if { $mom_sys_post_initialized > 1 } { return }


#************
uplevel #0 {


#=============================================================
proc MOM_set_csys {} {
#=============================================================

  if [llength [info commands PB_CMD_kin_set_csys] ] {
    PB_CMD_kin_set_csys
  }

# Sets the current ZCS which is the coordinate system
# corresponding to current CSYS and is used during simulation.
#
# Note: Don't position ZCS on a K-component that moves or rotates
# since ZCS most of time has to be stationary, except when
# a table is mounted on a linear axis and the control expects
# coordinates in the moving ZCS.

  global sim_mtd_initialized
  if $sim_mtd_initialized {
    if [llength [info commands PB_VNC_csys] ] {
      PB_VNC_csys
    }
  }
}


#=============================================================
proc MOM_msys {} {
#=============================================================
# Sets the current ZCS which is the coordinate system
# corresponding to current CSYS and is used during simulation.
#
# Note: Don't position ZCS on a K-component that moves or rotates
# since ZCS most of time has to be stationary, except when
# a table is mounted on a linear axis and the control expects
# coordinates in the moving ZCS.

  global sim_mtd_initialized
  if $sim_mtd_initialized {
    if [llength [info commands PB_VNC_csys] ] {
      PB_VNC_csys
    }
  }
}


#=========================
# Linked posts definition
#=========================
   set mom_sys_master_post [file rootname [file tail $mom_event_handler_file_name]]
   set mom_sys_postname(5_axis)                  "$mom_sys_master_post"

   set mom_sys_postname(turning_main)            "300sy_lathe_tool_tip"



#=============================================================
proc MOM_end_of_program { } {
#=============================================================
   global mom_head_type mom_machine_mode mom_tool_name mom_group_name group_output_file
   global mom_machine_time mom_tool_count mom_tool_use mom_tool_corner1_radius tool_data_name tool_data_diameter
   global mom_output_file_directory mom_output_file_basename mom_output_file_suffix tmp1_file_name ptp_file_name
   PB_CMD_nurbs_end_of_program

    switch $mom_machine_mode {
      MILL { }
      TURN { }
    }
#   MOM_output_literal "M1=5 M109"
 MOM_do_template spindle_off


MOM_set_seq_off
MOM_output_literal " "

MOM_output_literal "(     TIME:[format "%.2f" $mom_machine_time] MIN)"
MOM_output_literal ""

MOM_set_seq_on

   MOM_output_literal "M30"
#MOM_close_out_file $group_output_file($mom_group_name)
#   MOM_do_template end_of_program
#   MOM_set_seq_off
#   MOM_do_template rewind_stop_code
 #  PB_CMD_reprocess_eia
#**** The following procedure lists the tool list with time in commentary data



   LIST_FILE_TRAILER

#**** The following procedure closes the warning and listing files
   CLOSE_files



  # End of simulation
   global sim_mtd_initialized
   if $sim_mtd_initialized {
      if [llength [info commands PB_VNC_end_of_program] ] {
         PB_VNC_end_of_program
      }
   }
}

  incr mom_sys_post_initialized


} ;# uplevel
#***********


 # Initialize simulation
  global sim_mtd_initialized
  if $sim_mtd_initialized {
    if [llength [info commands PB_VNC_start_of_program] ] {
      PB_VNC_start_of_program
    }
  }
}


#=============================================================
proc PB_DELAY_TIME_SET { } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {set delay_time $mom_delay_revs}
    }
}



#=============================================================
proc MOM_before_motion { } {
#=============================================================
  global mom_motion_event mom_motion_type

    FEEDRATE_SET


    switch $mom_motion_type {
      ENGAGE   {PB_engage_move}
      APPROACH {PB_approach_move}
      FIRSTCUT {PB_first_cut}
      RETRACT  {PB_retract_move}
      RETURN   {PB_return_move}
    }

    if [llength [info commands PB_CMD_kin_before_motion] ] { PB_CMD_kin_before_motion }
    if [llength [info commands PB_CMD_before_motion] ]     { PB_CMD_before_motion }
}


#=============================================================
proc MOM_start_of_group {} {
#=============================================================
  global mom_sys_group_output mom_group_name group_level ptp_file_name kl_path
  global mom_sequence_number mom_sequence_increment mom_sequence_frequency
  global mom_sys_ptp_output pb_start_of_program_flag mom_parent_group_name

   global mom_logname mom_date mom_ug_version mom_part_name mom_event_handler_file_name mom_definition_file_name
  global mom_output_file_directory mom_output_file_basename mom_output_file_suffix

    if {[regexp NC_PROGRAM $mom_group_name] == 1} {set group_level 0 ; return}
 if {[hiset mom_parent_group_name]} { if {$mom_parent_group_name == $mom_group_name} {set group_level 0 ; return}}
   if {[hiset mom_sys_group_output]} { if {$mom_sys_group_output == "ON"} {   ; }}

    if {[hiset group_level]} {incr group_level} else {set group_level 1}
    if {$group_level > 1} {return}

    SEQNO_RESET ; #<4133654>
    MOM_reset_sequence $mom_sequence_number $mom_sequence_increment $mom_sequence_frequency

    PB_start_of_program ; set pb_start_of_program_flag 1
   MOM_do_template return_home
   MOM_do_template return_home_1

   set kl_path 0
}


#=============================================================
proc MOM_machine_mode {} {
#=============================================================
  global pb_start_of_program_flag mom_tool_name mom_head_name mom_tool_head kl_path
  global mom_operation_name mom_sys_change_mach_operation_name mom_machine_mode mom_tool_holder_angle

   set mom_sys_change_mach_operation_name $mom_operation_name

    if {$pb_start_of_program_flag == 0} {PB_start_of_program ; set pb_start_of_program_flag 1

    MOM_do_template return_home
   MOM_do_template return_home_1

   set kl_path 0
    }
    catch {PB_machine_mode}
   switch $mom_machine_mode {
      MILL {set mom_head_name "5_axis"}
      TURN {  set mom_head_name  "turning_main"}
    }
                   MOM_head
}


#=============================================================
proc PB_FORCE { option args } {
#=============================================================
   set adds [join $args]
   if { [info exists option] && [llength $adds] } {
      lappend cmd MOM_force
      lappend cmd $option
      lappend cmd [join $adds]
      eval [join $cmd]
   }
}


#=============================================================
proc PB_SET_RAPID_MOD { mod_list blk_list ADDR NEW_MOD_LIST } {
#=============================================================
  upvar $ADDR addr
  upvar $NEW_MOD_LIST new_mod_list
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2


   set new_mod_list [list]

   foreach mod $mod_list {
      switch $mod {
         "rapid1" {
            set elem $addr($traverse_axis1)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         "rapid2" {
            set elem $addr($traverse_axis2)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         "rapid3" {
            set elem $addr($mom_cycle_spindle_axis)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         default {
            set elem $mod
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
      }
   }
}


########################
# Redefine FEEDRATE_SET
########################
if [llength [info commands ugpost_FEEDRATE_SET] ] {
   rename ugpost_FEEDRATE_SET ""
}

if [llength [info commands FEEDRATE_SET] ] {
   rename FEEDRATE_SET ugpost_FEEDRATE_SET
} else {
   proc ugpost_FEEDRATE_SET {} {}
}


#=============================================================
proc FEEDRATE_SET {} {
#=============================================================
   if [llength [info commands PB_CMD_kin_feedrate_set] ] {
      PB_CMD_kin_feedrate_set
   } else {
      ugpost_FEEDRATE_SET
   }
}


#=============================================================
proc MOM_head { } {
#=============================================================
   global mom_warning_info mom_machine_mode
   global mom_sys_in_operation  cam_post_dir
   global mom_head_name mom_sys_postname
   global mom_load_event_handler
   global CURRENT_HEAD NEXT_HEAD
   global mom_sys_prev_mach_head mom_sys_curr_mach_head
   global mom_sys_head_change_init_program

#      set mom_load_event_handler \
#          [MOM_ask_env_var UGII_CAM_POST_DIR]$mom_sys_postname($CURRENT_HEAD).tcl

#      MOM_load_definition_file \
#          [MOM_ask_env_var UGII_CAM_POST_DIR]$mom_sys_postname($CURRENT_HEAD).def

#set mom_load_event_handler \\\\fs_opu\\post\\Mazatrol\\integrex_300\\$mom_sys_postname($mom_head_name).tcl
# MOM_load_definition_file  \\\\fs_opu\\post\\Mazatrol\\integrex_300\\$mom_sys_postname($mom_head_name).def
# set mom_load_event_handler  ${cam_post_dir}\\Mazatrol\\integrex_300\\$mom_sys_postname($mom_head_name).tcl
#   MOM_load_definition_file  ${cam_post_dir}\\Mazatrol\\integrex_300\\$mom_sys_postname($mom_head_name).def
 set mom_load_event_handler  \\\\Lh00\\mach\\post\\Mazatrol\\integrex_300\\$mom_sys_postname($mom_head_name).tcl
  MOM_load_definition_file   \\\\Lh00\\mach\\post\\Mazatrol\\integrex_300\\$mom_sys_postname($mom_head_name).def
      set mom_sys_head_change_init_program 1
   switch $mom_machine_mode {
      MILL {
        MOM_output_literal "M201"
        MOM_output_literal "G53.5"}
      TURN {
      	 MOM_output_literal "M202"
         MOM_output_literal "G53.5"}
    }

}


############## EVENT HANDLING SECTION ################


#=============================================================
proc PB_start_of_program { } {
#=============================================================
global mom_ug_version  mom_machine_name mom_date mom_logname
global mom_tool_name mom_tool_diameter mom_tool_corner1_radius
  # Initialize for sim
   global sim_mtd_initialized mom_output_file_basename mom_group_name mom_operation_name nm_part

   if $sim_mtd_initialized {
      if [llength [info commands PB_VNC_init_sim_vars] ] {
         PB_VNC_init_sim_vars
      }
   }

   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }
   PB_CMD_init_tools_var
   PB_CMD_init_vars

  set strname "" ; 
  if [llength [info commands PB_part_name] ] {
    set strname [ PB_part_name ]
  }
  set strmaterial "" ; 
  if [llength [info commands PB_part_material] ] {
    set strmaterial [ PB_part_material ]
  }
  MOM_set_seq_off
  MOM_output_literal "O0001"
#  set strname [string toupper $strname]
#  MOM_output_literal "( PART: $strname )" ; 
#  set strmaterial [string toupper $strmaterial]
#  MOM_output_literal "( MATERIAL: $strmaterial )" ;

		set mom_ug_version [string toupper $mom_ug_version]
		MOM_output_literal "( GENERATE BY: $mom_ug_version)"
		set mom_machine_name [string toupper $mom_machine_name]
		MOM_output_literal "( MACHINE: $mom_machine_name)"
		set mom_date [string toupper $mom_date]
		MOM_output_literal "( DATE: $mom_date)"
		set mom_logname [string toupper $mom_logname]
		MOM_output_literal "( PROGRAMMER: $mom_logname)"

   set line [format "TOOL: %s " $mom_tool_name ]
   if {[info exists mom_tool_diameter]==1} {
   	append line [format " D=%.2f"  [expr $mom_tool_diameter/1.0] ] ;
   }

   if {[info exists mom_tool_corner1_radius]==1} {
     if {![ EQ_is_zero $mom_tool_corner1_radius ] } {
  	 append line [format " r1=%.2f"  $mom_tool_corner1_radius ]
     }
   }

  MOM_output_literal "( $line )"
  MOM_output_literal "M201"
  MOM_output_literal "G21"
  MOM_output_literal "G90"
  MOM_set_seq_on

}
#=============================================================
proc MOM_operator_message {} {
#        
#=============================================================
     global mom_operator_message
     MOM_output_text "( $mom_operator_message)"
}

#=============================================================
proc MOM_start_of_path { } {
#=============================================================
  global mom_sys_in_operation kl_path
   set mom_sys_in_operation 1

  global first_linear_move ; set first_linear_move 0
   TOOL_SET MOM_start_of_path
  MOM_set_seq_off
   MOM_do_template start_of_path
   MOM_do_template start_of_path_1
  MOM_set_seq_on
   if [llength [info commands PB_CMD_kin_start_of_path] ] {
      PB_CMD_kin_start_of_path
   }

   PB_CMD_start_of_operation_force_addresses
   incr kl_path
   PB_CMD_Operation_Name
  PB_CMD_5axis_flag3_V_nol
}


#=============================================================
proc MOM_from_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev  mom_motion_type mom_kin_max_fpm
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET

}


#=============================================================
proc MOM_first_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change mom_tool_name

# MOM_output_literal "iiiiiiiiiiiiiiiiiiiiiiiiiiiii"

   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc PB_auto_tool_change { } {
#=============================================================

 # Retain tool name for sim when M06 is encountered.
  global sim_mtd_initialized
  if $sim_mtd_initialized {
    if [llength [info commands PB_VNC_pass_tool_param] ] {
      PB_VNC_pass_tool_param
    }
  }
   PB_CMD_tool_datas
}


#=============================================================
proc PB_manual_tool_change { } {
#=============================================================
   PB_CMD_tool_change_force_addresses
   MOM_do_template stop
}


#=============================================================
proc MOM_initial_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type mom_pos
  global mom_kin_max_fpm mom_motion_event mom_out_angle_pos
  global mom_machine_control_additional_commands
  global kl_polar mom_programmed_feed_rate mom_sys_leader mom_sys_lathe_x_double
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
	set mom_out_angle_pos(0) [format "%-.3f" $mom_out_angle_pos(0)]

   if { [EQ_is_equal $mom_programmed_feed_rate 0] } {
      MOM_rapid_move
   } else {
      MOM_linear_move
   }

}


#=============================================================
proc MOM_first_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event set mom_sys_lathe_x_double
  global kl_polar mom_programmed_feed_rate mom_pos mom_sys_leader kl_path
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET


   catch {MOM_$mom_motion_event}
}

#=============================================================
proc PB_approach_move { } {
#=============================================================
}


#=============================================================
proc PB_engage_move { } {
#=============================================================
}


#=============================================================
proc PB_first_cut { } {
#=============================================================
}


#=============================================================
proc PB_first_linear_move { } {
#=============================================================
}


#=============================================================
proc PB_retract_move { } {
#=============================================================
   global  mom_machine_mode mom_operation_name
}


#=============================================================
proc PB_return_move { } {
#=============================================================
}


#=============================================================
proc MOM_gohome_move { } {
#=============================================================
   MOM_rapid_move
}


#=============================================================
proc MOM_end_of_path { } {
#=============================================================

   if [llength [info commands PB_CMD_kin_end_of_path] ] {
      PB_CMD_kin_end_of_path
   }

   global mom_sys_in_operation kl_polar
   set mom_sys_in_operation 0

   global sim_mtd_initialized mom_machine_mode mom_tool_name
   if $sim_mtd_initialized {
      if [llength [info commands PB_VNC_end_of_path] ] {
         PB_VNC_end_of_path
      }
   }
 #    	MOM_output_literal "kl_polar $kl_polar"
  if {$kl_polar==6 ||$kl_polar==7} {
    	MOM_output_literal "G69.5"

    	    set mom_sys_lathe_x_double                    "1"
       	set kl_polar  0
}
global 5axis_flag
global i1 oper eng_flag i2 i3
if {$i1 >= 3 || ($i2>= 2 && $i3>= 2)} {

	set 5axis_flag [append 5axis_flag $oper " " $i1 " " AC " " ]
#	MOM_output_literal "5axis_flag  $5axis_flag 11111111111111 "

	return
}
if {$i2>= 2 } {

	set 5axis_flag [append 5axis_flag $oper " " $i2 " " A " " ]
#	MOM_output_literal "5axis_flag  $5axis_flag 222222222222222222222"

		return
}
if {$i3>= 2  } {

	set 5axis_flag [append 5axis_flag $oper " " $i3 " " C " " ]
#	MOM_output_literal "5axis_flag  $5axis_flag 3333333333333333333 "

		return
}
  set eng_flag 0


}

#=============================================================
proc MOM_end_of_group { } {
#=============================================================

   if [llength [info commands PB_CMD_kin_end_of_path] ] {
      PB_CMD_kin_end_of_path
   }

   global mom_sys_in_operation mom_parent_group_name mom_group_name mom_pos
   set mom_sys_in_operation 0

   global sim_mtd_initialized group_level kl_polar mom_sys_lathe_x_double
   if $sim_mtd_initialized {
      if [llength [info commands PB_VNC_end_of_path] ] {
         PB_VNC_end_of_path
      }
   }
#   MOM_output_literal " group_level $group_level"
   if {[hiset mom_parent_group_name]} { if {$mom_parent_group_name == $mom_group_name && $group_level!=0} {  return}}
    if {$kl_polar==1} {
    	MOM_output_literal " G13.1"
  set mom_sys_leader(Y)                         "Y"
    	    set mom_sys_lathe_x_double                    "1"

}
    if {$kl_polar==13} {
    	MOM_output_literal "G49"
}
  if {$kl_polar==2||$kl_polar==4} {
    	MOM_output_literal "G69.5"

    	    set mom_sys_lathe_x_double                    "1"
       	set kl_polar  0
}
                MOM_do_template return_home
                MOM_do_template return_home_1
              MOM_opstop
      	set kl_polar  0
}

#=============================================================
proc MOM_tool_change { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc MOM_length_compensation { } {
#=============================================================
   TOOL_SET MOM_length_compensation
   MOM_do_template tool_length_adjust
}


#=============================================================
proc MOM_set_modes { } {
#=============================================================
   MODES_SET
}


#=============================================================
proc MOM_spindle_rpm { } {
#=============================================================
   SPINDLE_SET
   MOM_force Once S M_spindle
   MOM_do_template spindle_rpm
}


#=============================================================
proc MOM_spindle_off { } {
#=============================================================
   MOM_do_template spindle_off
}


#=============================================================
proc MOM_coolant_on { } {
#=============================================================
   COOLANT_SET
}


#=============================================================
proc MOM_coolant_off { } {
#=============================================================
   COOLANT_SET
   MOM_do_template coolant_off
}


#=============================================================
proc PB_feedrates { } {
#=============================================================
}


#=============================================================
proc MOM_cutcom_on { } {
#=============================================================
   CUTCOM_SET
}


#=============================================================
proc MOM_cutcom_off { } {
#=============================================================
   CUTCOM_SET
   MOM_do_template cutcom_off
}


#=============================================================
proc MOM_delay { } {
#=============================================================
   PB_DELAY_TIME_SET
   MOM_do_template delay
}


#=============================================================
proc MOM_opstop { } {
#=============================================================
   MOM_do_template opstop
}


#=============================================================
proc MOM_auxfun { } {
#=============================================================
   MOM_do_template auxfun
}


#=============================================================
proc MOM_prefun { } {
#=============================================================
   MOM_do_template prefun
}


#=============================================================
proc MOM_load_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
}


#=============================================================
proc MOM_stop { } {
#=============================================================
   MOM_do_template stop
}


#=============================================================
proc MOM_tool_preselect { } {
#=============================================================
  global mom_tool_preselect_number mom_tool_number mom_next_tool_number
   if {[info exists mom_tool_preselect_number]} {
      set mom_next_tool_number $mom_tool_preselect_number
   }
}
#=============================================================
proc MOM_set_axis { } {
#=============================================================
   global mom_axis_position mom_axis_position_value

}


#=============================================================
proc MOM_linear_move { } {
#=============================================================
  global feed_mode mom_feed_rate mom_kin_rapid_feed_rate

   if { $feed_mode == "IPM" || $feed_mode == "MMPM" } {
      if { [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate] } {
         MOM_rapid_move
         return
      }
   }

  global first_linear_move

   if { !$first_linear_move } {
      PB_first_linear_move
      incr first_linear_move
   }

   MOM_do_template linear_move
}


#=============================================================
proc MOM_circular_move { } {
#=============================================================
#   CIRCLE_SET
   MOM_do_template circular_move
}


#=============================================================
proc MOM_rapid_move { } {
#=============================================================
  global rapid_spindle_inhibit rapid_traverse_inhibit
  global spindle_first is_from
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2
  global mom_motion_event kl_polar mom_tool_number

   set aa(0) X ; set aa(1) Y ; set aa(2) Z
   RAPID_SET
   set rapid_traverse_blk {G_feed G_motion X Y Z fourth_axis fifth_axis}
   set rapid_traverse_mod {}
   PB_SET_RAPID_MOD $rapid_traverse_mod $rapid_traverse_blk aa mod_traverse
   PB_FORCE Once $mod_traverse

   if {$kl_polar == 3} {
   	 MOM_do_template rapid_traverse_1
                           MOM_do_template rapid_traverse_2
                           set kl_polar  13
    } else {
   MOM_do_template rapid_traverse
}
#   MOM_do_template rapid_move_1
}


#=============================================================
proc MOM_cycle_off { } {
#=============================================================
 global cycle_name
   switch $cycle_name {
      TAP_WITH_CHUCK {
      }
      TAP_WITHOUT_CHUCK {
         MOM_do_template cycle_off_stopre
         MOM_do_template cycle_off_stopre_1
      }
      default {
         MOM_do_template cycle_off
      }
   }
}


#=============================================================
proc MOM_cycle_plane_change { } {
#=============================================================
  global cycle_init_flag

   set cycle_init_flag TRUE
}

#=============================================================
proc MOM_cdrill { } {
#=============================================================
  global cycle_name mom_machine_control_additional_commands
  global cycle_init_flag

   set cycle_init_flag TRUE
	if { $mom_machine_control_additional_commands == "tap_with_chuck"} {

   set cycle_name TAP_WITH_CHUCK
MOM_suppress once G_cycle
}
	if {$mom_machine_control_additional_commands == "tap_without_chuck"} {

   set cycle_name TAP_WITHOUT_CHUCK
MOM_force once F
MOM_suppress once K

}

   CYCLE_SET

}


#=============================================================
proc MOM_cdrill_move { } {
#=============================================================
  global cycle_init_flag mom_machine_control_additional_commands mom_sys_cycle_tap_with_chuck_code
  global mom_spindle_direction mom_cycle_feed_to mom_prev_pos mom_sys_cycle_tap_without_chuck_code
  global mom_cycle_rapid_to

	if {$mom_machine_control_additional_commands == "tap_with_chuck"} {
 if { $mom_prev_pos(2)== $mom_cycle_feed_to } {

 if { $mom_spindle_direction== "CCLW" } {
    set  mom_spindle_direction   "CLW"

} elseif {$mom_spindle_direction== "CLW"} {
    set  mom_spindle_direction   "CCLW"

  }
}
   MOM_do_template cycle_tap_with_chuck
}
	if {$mom_machine_control_additional_commands == "tap_without_chuck"} {
 if { $mom_prev_pos(2)== $mom_cycle_rapid_to } {

MOM_output_literal "G0 C1=0"
MOM_output_literal "BRISK FFWON"
}
 if { $mom_prev_pos(2)== $mom_cycle_feed_to } {
         set mom_sys_cycle_tap_without_chuck_code 332
 }
   MOM_do_template cycle_tap_without_chuck
MOM_force once K
}


   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL
   CYCLE_SET
}


#=============================================================
proc MOM_drill_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_drill
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_drill_dwell_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_drill_dwell
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_deep { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DEEP
   CYCLE_SET
}


#=============================================================
proc MOM_drill_deep_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_drill_deep
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_break_chip { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_BREAK_CHIP
   CYCLE_SET
}


#=============================================================
proc MOM_drill_break_chip_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_drill_break_chip
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_tap { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name TAP
   CYCLE_SET
}


#=============================================================
proc MOM_tap_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_tap
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE
   CYCLE_SET
}


#=============================================================
proc MOM_bore_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_bore
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_drag { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_DRAG
   CYCLE_SET
}


#=============================================================
proc MOM_bore_drag_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_bore_drag
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_no_drag { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_NO_DRAG
   CYCLE_SET
}


#=============================================================
proc MOM_bore_no_drag_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_bore_no_drag
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_manual { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_MANUAL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_manual_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_bore_manual
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_dwell_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_bore_dwell
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_back { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_BACK
   CYCLE_SET
}


#=============================================================
proc MOM_bore_back_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_bore_back
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_manual_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_MANUAL_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_manual_dwell_move { } {
#=============================================================
  global cycle_init_flag

   MOM_do_template cycle_bore_manual_dwell
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_sequence_number { } {
#=============================================================
   SEQNO_SET
}


#=============================================================
proc PB_CMD_FEEDRATE_NUMBER { } {
#=============================================================
#
#  This custom command allows you to modify the feed rate number
#  after it has been calculated by the system
#
   global mom_feed_rate_number

   set mom_sys_frn_factor 1.0

   if [info exists mom_feed_rate_number] {
      return [expr $mom_feed_rate_number * $mom_sys_frn_factor]
   } else {
      return 0.0
   }
}


#=============================================================
proc PB_CMD_before_motion { } {
#=============================================================
    global mom_out_angle_pos mom_current_motion mom_motion_event mom_nxt_tool_axis
    global mom_template_type mom_sys_lathe_x_double  mom_pos mom_sys_leader
    global  kl_path kl_polar mom_mcs_goto global RAD2DEG prev_out_angle_pos
     global mom_prev_mcs_goto mom_prev_pos mom_pos_arc_center mom_arc_center
	set mom_out_angle_pos(0) [format "%-.3f" $mom_out_angle_pos(0)]
		set mom_out_angle_pos(1) [format "%-.3f" $mom_out_angle_pos(1)]
#	MOM_output_literal "$mom_motion_event $mom_current_motion $mom_out_angle_pos(0) $kl_path"
#	 	      	MOM_output_literal "$mom_current_motion  $mom_template_type $mom_out_angle_pos(0) $kl_path"
	if { $mom_current_motion == "initial_move" } {
	   MOM_do_template auto_tool_change
	   	 	      	 MOM_output_literal "G30W0"
	}
	if { $mom_motion_event == "from_move" } {
	  set  kl_polar   5
	  return
	}
#	MOM_output_literal "$mom_motion_event $mom_current_motion $mom_out_angle_pos(0) $kl_path"
 if { (($mom_current_motion == "first_move" ||  $mom_current_motion == "initial_move")|| $kl_polar==5 )\
  && $mom_out_angle_pos(0)==0.0 && $kl_path ==1 } {
	 	 set  kl_polar   1
	 	    MOM_do_template initial_move_2
	 	      	 MOM_output_literal "G17"
	 	      	 MOM_output_literal "G28V0"
                       MOM_do_template G123.1
#                           	         	        MOM_do_template frame_G128_1
    	    set mom_sys_lathe_x_double                    "2"
         	   MOM_force once G_motion X Y Z fourth_axis fifth_axis
   	 	                      MOM_do_template initial_move_3
   MOM_output_literal "G12.1"
     MOM_force once G_motion
       set mom_sys_leader(Y)                         "C"

	}
	if { (($mom_current_motion == "first_move" || $mom_current_motion == "initial_move") ||  $kl_polar==5)\
	&&($mom_template_type == "mill_planar" || $mom_template_type == "mill_contour" ||$mom_template_type == "drill")  && $mom_out_angle_pos(0)!=0.0 \
	  && $mom_out_angle_pos(0)!=90.0 && $kl_path ==1 } {
		        set  kl_polar   2
                  MOM_do_template initial_move_2

    	    set mom_sys_lathe_x_double                    "1"

    	          	MOM_output_literal "M250"
         	        MOM_do_template fourth_axis_rotate_move
    	              MOM_output_literal "M251"
    	               	MOM_output_literal "G17"
    	               	 	MOM_output_literal "G28V0"
    	                    MOM_do_template G123.1
    	         	        MOM_do_template frame_G128
    	         	             MOM_do_template G122.1
    	         	               MOM_force once G_motion fifth_axis
    	         	MOM_do_template   fifth_axis_rotate_move
    	         	   MOM_force once X Y Z
}
if { (($mom_current_motion == "first_move" || $mom_current_motion == "initial_move") ||  $kl_polar==5)\
	&&($mom_template_type == "mill_planar" || $mom_template_type == "mill_contour" || $mom_template_type == "drill")  && $mom_out_angle_pos(0)==90.0  && \
	 $kl_path ==1  } {
		        set  kl_polar   4
		           	           MOM_do_template initial_move_2

    	    set mom_sys_lathe_x_double                    "1"

    	          	MOM_output_literal "M250"
         	        MOM_do_template fourth_axis_rotate_move
    	              MOM_output_literal "M251"
    	               	MOM_output_literal "G17"
    	               	 	MOM_output_literal "G28V0"
    	                    MOM_do_template G123.1
    	         	        MOM_do_template frame_G128
    	         	             MOM_do_template G122.1
    	         	               MOM_force once G_motion fifth_axis
    	         	MOM_do_template   fifth_axis_rotate_move
    	         	   MOM_force once X Y Z
}
	if { ($mom_current_motion == "first_move"  ||  $kl_polar==5)\
	&&($mom_template_type == "mill_planar" || $mom_template_type == "mill_contour"|| $mom_template_type == "drill")  && $mom_out_angle_pos(0)!=0.0 \
	  && $mom_out_angle_pos(0)!=90.0 && ( $mom_out_angle_pos(0) != $prev_out_angle_pos(0) ) && $kl_path !=1} {
		        set  kl_polar   6


		    	           MOM_do_template initial_move_2

    	    set mom_sys_lathe_x_double                    "1"

    	          	MOM_output_literal "M250"
         	        MOM_do_template fourth_axis_rotate_move
    	              MOM_output_literal "M251"
    	                 	MOM_output_literal "G17"
    	                 	   	MOM_output_literal "G28V0"
    	                    MOM_do_template G123.1
    	         	        MOM_do_template frame_G128
    	         	             MOM_do_template G122.1
    	         	               MOM_force once G_motion fifth_axis
    	         	MOM_do_template   fifth_axis_rotate_move
    	         	   MOM_force once X Y Z
}
if { ($mom_current_motion == "first_move" ||  $kl_polar==5)\
	&&($mom_template_type == "mill_planar" || $mom_template_type == "mill_contour" || $mom_template_type == "drill")  && $mom_out_angle_pos(0)==90.0  && \
	(( $mom_out_angle_pos(0) != $prev_out_angle_pos(0) && $mom_out_angle_pos(1) != $prev_out_angle_pos(1))  || ( $mom_out_angle_pos(0) == $prev_out_angle_pos(0) && $mom_out_angle_pos(1) != $prev_out_angle_pos(1))) && $kl_path !=1} {
		        set  kl_polar  7

		              set v123  [ expr ($kl_path-1)]
		        if {  $v123 ==1 } {
		           MOM_output_literal "G69.5"
		          }

		   	           MOM_do_template initial_move_2

    	    set mom_sys_lathe_x_double                    "1"

    	          	MOM_output_literal "M250"
    	          	   MOM_force once fourth_axis
         	        MOM_do_template fourth_axis_rotate_move
    	              MOM_output_literal "M251"
    	                   	MOM_output_literal "G17"
    	                   	     	MOM_output_literal "G28V0"
    	                    MOM_do_template G123.1
    	         	        MOM_do_template frame_G128
    	         	             MOM_do_template G122.1
    	         	               MOM_force once G_motion fifth_axis
    	         	MOM_do_template   fifth_axis_rotate_move
    	         	   MOM_force once X Y Z
}

	if { (($mom_current_motion == "first_move" || $mom_current_motion == "initial_move") ||  $kl_polar==5)\
	&&$mom_template_type == "mill_multi-axis"  && $mom_out_angle_pos(0)!=0.0 && $kl_path ==1  } {
		        set  kl_polar   3

    	    set mom_sys_lathe_x_double                    "1"
    	           MOM_do_template initial_move_2
    	              	MOM_output_literal "G28V0"
    	                           MOM_do_template G123.1
    	         	        MOM_do_template frame_G128E1
    	         	                     MOM_do_template G122.1
    	         	                     MOM_output_literal "M250"
    	         	   MOM_force once G_motion X Y Z
}
#  
	if {  $kl_polar==4 || $kl_polar==7  } {
		set aaa [ expr (cos($mom_out_angle_pos(1)))]
				set bbb [ expr (sin($mom_out_angle_pos(1)))]
	#	MOM_output_literal " aaa   $aaa  bbb   $bbb  $RAD2DEG"
  #   set   mom_pos(0) [ expr ($mom_mcs_goto(0)*cos($mom_out_angle_pos(1)/$RAD2DEG) +$mom_mcs_goto(1)*sin($mom_out_angle_pos(1)/$RAD2DEG))]
  #   set   mom_pos(1) [ expr (-$mom_mcs_goto(0)*sin($mom_out_angle_pos(1)/$RAD2DEG) +$mom_mcs_goto(1)*cos($mom_out_angle_pos(1)/$RAD2DEG))]
}
	if {  $kl_polar==2 || $kl_polar==6 || $kl_polar==4 || $kl_polar==7  } {
		set a1 [ expr (cos($mom_out_angle_pos(1)/$RAD2DEG))]
		set b1 [ expr (sin($mom_out_angle_pos(1)/$RAD2DEG))]
		set a2 [ expr (cos($mom_out_angle_pos(0)/$RAD2DEG))]
		set b2 [ expr (sin($mom_out_angle_pos(0)/$RAD2DEG))]
#		MOM_output_literal " 888888888888888888888888888888888888888888"
     set   mom_pos(0) [ expr (($mom_mcs_goto(0)*$a1 +$mom_mcs_goto(1)*$b1)*$a2-$mom_mcs_goto(2)*$b2)]
     set   mom_pos(2) [ expr (($mom_mcs_goto(0)*$a1 +$mom_mcs_goto(1)*$b1)*$b2+$mom_mcs_goto(2)*$a2)]

     set   mom_prev_pos(0) [ expr (($mom_prev_mcs_goto(0)*$a1 +$mom_prev_mcs_goto(1)*$b1)*$a2-$mom_prev_mcs_goto(2)*$b2)]
     set   mom_prev_pos(2) [ expr (($mom_prev_mcs_goto(0)*$a1 +$mom_prev_mcs_goto(1)*$b1)*$b2+$mom_prev_mcs_goto(2)*$a2)]

     set   mom_pos_arc_center(0) [ expr (($mom_arc_center(0)*$a1 +$mom_arc_center(1)*$b1)*$a2-$mom_arc_center(2)*$b2)]
     set   mom_pos_arc_center(2) [ expr (($mom_arc_center(0)*$a1 +$mom_arc_center(1)*$b1)*$b2+$mom_arc_center(2)*$a2)]
 #    MOM_output_literal " $mom_pos(0) $mom_pos(2) $mom_prev_pos(0) $mom_prev_pos(2) $mom_pos_arc_center(0) $mom_pos_arc_center(2)"
}
set prev_out_angle_pos(0) [format "%-.3f" $mom_out_angle_pos(0)]
set prev_out_angle_pos(1) [format "%-.3f" $mom_out_angle_pos(1)]
}
#=============================================================
proc PB_CMD_tool_datas { } {
#=============================================================
global mom_tool_name mom_tool_number mom_tool_diameter mom_tool_corner1_radius
global tool_data_name tool_data_diameter tool_data_corner1_radius tool_i  oper
global mom_sys_coolant_code
global mom_warning_info

   if {$mom_tool_number == 0} {
	set mom_warning_info "  \"$oper''     ."
	MOM_output_to_listing_device $mom_warning_info
	PB_CMD_Messages
#	MOM_abort "  ''$oper''      !!!!"
   }

   set line [format "TOOL: %s " $mom_tool_name ]
   if {[info exists mom_tool_diameter]==1} {
   	append line [format " D=%.2f"  [expr $mom_tool_diameter/1.0] ] ;
  	set tool_data_diameter($tool_i) $mom_tool_diameter
   }

   if {[info exists mom_tool_corner1_radius]==1} {
     if {![ EQ_is_zero $mom_tool_corner1_radius ] } {
  	 append line [format " r1=%.2f"  $mom_tool_corner1_radius ]
  	 set tool_data_corner1_radius($tool_i) $mom_tool_corner1_radius
     }
   }

   MOM_output_literal "($line)"
   set tool_data_name($tool_i)  $mom_tool_name
   set tool_i [expr $tool_i+1]

}

#=============================================================
proc PB_CMD_init_tools_var { } {
#=============================================================
global tool_i i1 5axis
global start_of_program_flag i2 i3


	set start_of_program_flag "0"



	set i1 0
	set i2 0
	set i3 0
	uplevel #0 {
		set tool_i "0"
		set 5axis 0
		}
}
#=============================================================
proc PB_CMD_init_vars { } {
#=============================================================
global G10 mom_warning_info G68

global 5axis_flag 5axis_flag2 5axis_flag_for_end eng_flag

global spline_oper G06_flag

global mom_kin_4th_axis_min_limit
global mom_kin_4th_axis_max_limit

global mom_msys_origin nol1 nol2 nol3
global mom_contact_status D_flag

# set D_flag 0

set mom_warning_info ""
set 5axis_flag ""
set 5axis_flag2 0
set 5axis_flag_for_end 0

}

#=============================================================
proc PB_CMD_Operation_Name { } {
#=============================================================
global mom_operation_name oper

set oper $mom_operation_name
#MOM_output_literal "($oper)"
}

#=============================================================
proc PB_CMD_5axis_flag3_V_nol { } {
#=============================================================
global 5axis_flag3 i1 i2 i3

set 5axis_flag3 0
set i1 0
set i2 0
set i3 0
}

#=============================================================
proc PB_CMD_reprocess_eia { } {
#=============================================================
global ptp_file_name 5axis_flag_for_end mom_definition_file_name 5axis_flag
global tmp_mess_file name_operation mom_warning_info

set tmp_file_name "${ptp_file_name}_"

if {[file exists $tmp_file_name]} {
	MOM_remove_file $tmp_file_name
}

MOM_close_output_file $ptp_file_name
file rename $ptp_file_name $tmp_file_name
set ifile [open $tmp_file_name r]
set ofile [open $ptp_file_name w]

global mom_machine_time mom_group_name mom_operation_name
global mom_tool_count mom_tool_use
global tool_data_name tool_data_diameter tool_data_corner1_radius
global mom_output_file_basename
global mom_logname mom_ug_version mom_date mom_part_name mom_machine_name

set 5axis 0
set buf ""

while { [gets $ifile buf] > 0 } {
	set str6 [string length $buf]
	set str7 [expr $str6-2]
	set str8 [string range $buf 1 $str7]

	for { set nn 0 } { $nn < [llength $5axis_flag] } { set nn [expr $nn+3]} {
		if {$str8 == [lindex $5axis_flag $nn]} {
		if {"AC" == [lindex $5axis_flag [expr $nn+2]]} { set 5axis 1 }
		if {"A" == [lindex $5axis_flag [expr $nn+2]]} { set 5axis 2 }
		if {"C" == [lindex $5axis_flag [expr $nn+2]]} { set 5axis 3 }
		    }
	}

	if {[string index [lindex $buf 0] 0] == "("} {
		set name_operation $buf
		puts $ofile $buf
	} elseif {[lindex $buf 1] == "M43" && ($5axis == 0 ||$5axis == 2) } {
		# puts $ofile "GGGGGG"
	} elseif {[lindex $buf 1] == "M44" && ($5axis == 0 ||$5axis == 2)} {
		set str9 [lindex $buf 0]
#		set 5axis 0
	} elseif {[lindex $buf 1] == "M44" && ($5axis == 1 ||$5axis == 3)} {
		puts $ofile $buf
#		set 5axis 0
	  } elseif {[lindex $buf 1] == "M46" && ($5axis == 0 ||$5axis == 3)} {
		# puts $ofile "GGGGGG"
	} elseif {[lindex $buf 1] == "M47" && ($5axis == 0||$5axis == 3)} {
		set str9 [lindex $buf 0]
		set 5axis 0
	} elseif {[lindex $buf 1] == "M47" && ($5axis == 1||$5axis == 2)} {
		puts $ofile $buf
		set 5axis 0
	} elseif {([lindex $buf 1] == "G41" || [lindex $buf 1] == "G42") && $5axis == 1} {
		set mom_warning_info " 5-          "
		append mom_warning_info "!!!"
		append mom_warning_info "\n "
		append mom_warning_info "\n\t  - ''$name_operation''"
		#MOM_output_to_listing_device $mom_warning_info
		PB_CMD_Messages
		MOM_remove_file $tmp_file_name
		MOM_open_output_file $ptp_file_name
		MOM_abort " _     !!!"
	} elseif {[lindex $buf 1] == "G68"} {
		set mom_warning_info "   ,   G54.2 "
		append mom_warning_info "   !!!"
		append mom_warning_info "\n "
		append mom_warning_info "\n\t\t        "
		append mom_warning_info "\n "
		append mom_warning_info "\n        ,   G54.2,"
		append mom_warning_info "\n "
		append mom_warning_info "\n\t\t      ."
		append mom_warning_info "\n "
 		append mom_warning_info "\n\t\t\t\t  - ''$name_operation''"
		#MOM_output_to_listing_device $mom_warning_info
		PB_CMD_Messages
		MOM_remove_file $tmp_file_name
		MOM_open_output_file $ptp_file_name
		MOM_abort "  !!!!!!!!!!"
	} else {
		puts $ofile $buf
	}

}
	close $ifile
	close $ofile
	MOM_remove_file $tmp_file_name
	MOM_open_output_file $ptp_file_name
}



#=============================================================
proc PB_CMD_clamp_fifth_axis { } {
#=============================================================
#
#  This procedure is used by auto clamping to output the code
#  needed to clamp the fifth axis.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#
#  MOM_output_literal "M210"
}


#=============================================================
proc PB_CMD_clamp_fourth_axis { } {
#=============================================================
#
#  This procedure is used by auto clamping to output the code
#  needed to clamp the fourth axis.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#
#  MOM_output_literal "M10"
}


#=============================================================
proc PB_CMD_end_of_alignment_character { } {
#=============================================================
 # Return sequnece number back to orignal
 # This command may be used with the command "PM_CMD_start_of_alignment_character"

  global mom_sys_leader saved_seq_num
  set mom_sys_leader(N) $saved_seq_num
}


#=============================================================
proc PB_CMD_fifth_axis_rotate_move { } {
#=============================================================
#
#  This procedure is used by the ROTATE ude command to output a
#  fifth axis rotary move.  You can use the NC Data Definitions
#  section of postbuilder to modify the fifth_axis_rotary_move
#  block template.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#

  MOM_force once fifth_axis
  MOM_do_template fifth_axis_rotate_move
}


#=============================================================
proc PB_CMD_fourth_axis_rotate_move { } {
#=============================================================
#
#  This procedure is used by the ROTATE ude command to output a
#  fourth axis rotary move.  You can use the NC Data Definitions
#  section of postbuilder to modify the fourth_axis_rotary_move
#  block template.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#

  MOM_force once fourth_axis
  MOM_do_template fourth_axis_rotate_move
}


#=============================================================
proc PB_CMD_g68_csys { } {
#=============================================================
uplevel #0 {
proc MOM_set_csys {} {
global mom_kin_coordinate_system_type
if {$mom_kin_coordinate_system_type != "CSYS"} {return}

#
#  This custom command will output the code needed to cause a coordinate
#  system translation and rotation on the control.  Starting in NX2 a
#  MOM_set_csys event with a coordinate system type and matrix will be
#  output at the start of every tool path where the MCS changes.  If the
#  coordinate system type is csys, the coordinate system  matrix that
#  will be converted into the rotations and translations needed.
#
#  This custom command can be modified to output the code need for a specific
#  control.  For Fanuc, Siemens, Heidenhain and Mazatrol, the specific code
#  is included in those controls.
#
#  This custom command is used primarily for head/table five-axis or
#  head/head five-axis machine tools.
#
set type siemens
#  Choices are fanuc, siemens, heidenhain_iso, heidenhain_conv, mazatrol
#  These custom commands are intended for general cases.  You may find that
#  you need to make some adjustments to get the desired output.
#

global mom_csys_matrix
global RAD2DEG

set m0 $mom_csys_matrix(0)
set m1 $mom_csys_matrix(1)
set m3 $mom_csys_matrix(3)
set m4 $mom_csys_matrix(4)
set m6 $mom_csys_matrix(6)
set m7 $mom_csys_matrix(7)
set m8 $mom_csys_matrix(8)

set cos_b_sq [expr $m0*$m0 + $m3*$m3]

if {[EQ_is_equal $cos_b_sq 0.0]} {

    set cos_b 0.0
    set cos_c 1.0
    set cos_a $m4
    set sin_c 0.0

    if {$m6 < 0.0} {

        set sin_b 1.0
        set sin_a $m1

    } else {

        set sin_b -1.0
        set sin_a [expr -$m3]

    }

} else {

    set cos_b [expr sqrt($cos_b_sq)]
    set sin_b [expr -$m6]

    set cos_a [expr $m8/$cos_b]
    set sin_a [expr $m7/$cos_b]

    set cos_c [expr $m0/$cos_b]
    set sin_c [expr $m3/$cos_b]

}

set A [expr -atan2($sin_a,$cos_a)*$RAD2DEG]
set B [expr -atan2($sin_b,$cos_b)*$RAD2DEG]
set C [expr -atan2($sin_c,$cos_c)*$RAD2DEG]
if {[EQ_is_lt $A 0.0]} {set A [expr $A+360.0]}
if {[EQ_is_lt $B 0.0]} {set B [expr $B+360.0]}
if {[EQ_is_lt $C 0.0]} {set C [expr $C+360.0]}

set X [format "%.4f" $mom_csys_matrix(9)]
set Y [format "%.4f" $mom_csys_matrix(10)]
set Z [format "%.4f" $mom_csys_matrix(11)]
set A [format "%.4f" $A]
set B [format "%.4f" $B]
set C [format "%.4f" $C]

#MOM_output_literal "X=$X Y=$Y Z=$Z A=$A  B=$B  C=$C"

#set m0 [format "%.3f" $mom_csys_matrix(0)]
#set m1 [format "%.3f" $mom_csys_matrix(1)]
#set m2 [format "%.3f" $mom_csys_matrix(2)]
#set m3 [format "%.3f" $mom_csys_matrix(3)]
#set m4 [format "%.3f" $mom_csys_matrix(4)]
#set m5 [format "%.3f" $mom_csys_matrix(5)]
#set m6 [format "%.3f" $mom_csys_matrix(6)]
#set m7 [format "%.3f" $mom_csys_matrix(7)]
#set m8 [format "%.3f" $mom_csys_matrix(8)]
#MOM_output_literal "m0=$m0 m1=$m1 m2=$m2"
#MOM_output_literal "m3=$m3 m4=$m4 m5=$m5"
#MOM_output_literal "m6=$m6 m7=$m7 m8=$m8"

global mom_kin_4th_axis_plane
global mom_kin_5th_axis_plane
global mom_kin_4th_axis_direction
global mom_kin_5th_axis_direction
global mom_kin_4th_axis_leader
global mom_kin_5th_axis_leader
global mom_out_angle_pos
global mom_prev_out_angle_pos
global mom_sys_leader
global mom_pos

switch $mom_kin_4th_axis_plane {
    XY {set mom_pos(3) $C}
    ZX {set mom_pos(3) $B}
    YZ {set mom_pos(3) $A}
}

switch $mom_kin_5th_axis_plane {
    XY {set mom_pos(4) $C}
    ZX {set mom_pos(4) $B}
    YZ {set mom_pos(4) $A}
}

if {![info exists mom_prev_out_angle_pos(0)]} {
    set mom_prev_out_angle_pos(0) [MOM_ask_address_value fourth_axis]
    if {$mom_prev_out_angle_pos(0) == ""} {set mom_prev_out_angle_pos(0) 0.0}
}
if {![info exists mom_prev_out_angle_pos(1)]} {
    set mom_prev_out_angle_pos(1) [MOM_ask_address_value fifth_axis]
    if {$mom_prev_out_angle_pos(1) == ""} {set mom_prev_out_angle_pos(1) 0.0}
}

set mom_out_angle_pos(0) [ROTSET $mom_pos(3) $mom_prev_out_angle_pos(0) $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
set mom_out_angle_pos(1) [ROTSET $mom_pos(4) $mom_prev_out_angle_pos(1) $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)]

PB_CMD_fourth_axis_rotate_move
PB_CMD_fifth_axis_rotate_move

if {$type == "siemens"} {
    MOM_output_literal "TRANS X$X Y$Y Z$Z"
    if {$A != "undefined"} {MOM_output_literal "AROT X $A"}
    if {$B != "undefined"} {MOM_output_literal "AROT Y $B"}
    if {$C != "undefined"} {MOM_output_literal "AROT Z $C"}
} elseif {$type == "fanuc"} {
    if {![EQ_is_equal $A 0.0] && ![EQ_is_equal $B 0.0] && ![EQ_is_equal $C 0.0]} {
MOM_output_literal "(Fanuc does not support three rotations)"
    } else {
        set a 0
        set b 0
        if {![EQ_is_equal $A 0.0]} {
            MOM_output_literal "G68 X$X Y$Y Z$Z I1 J0 K0 R$A"
            set a 1
        }
        if {![EQ_is_equal $B 0.0]} {
            if {$a == 0} {
                MOM_output_literal "G68 X$X Y$Y Z$Z I0 J1 K0 R$B"
            } else {
                MOM_output_literal "G68 I0 J1 K0 R$B"
            }
            set b 1
        }
        if {![EQ_is_equal $C 0.0]} {
            if {$a == 0 && $b == 0} {
                MOM_output_literal "G68 X$X Y$Y Z$Z I0 J0 K1 R$C"
            } else {
                MOM_output_literal "G68 I0 J0 K1 R$C"
            }
        }
    }
} elseif {$type == "heidenhain_iso"} {
    MOM_output_literal "G7 L1=1 X5 $X Y5 $Y Z5 $Z A5 $A B5 $B C5 $C"
} elseif {$type == "heidenhain_conv"} {

    MOM_output_literal "LBL 201"
    MOM_output_literal "CYCL DEF 19.0"
    MOM_output_literal "CYCL DEF 19.1 A0.0 B0.0 C0.0"
    MOM_output_literal "CYCL DEF 19.0"
    MOM_output_literal "CYCL DEF 19.1"
    MOM_output_literal "CYCL DEF 7.0"
    MOM_output_literal "CYCL DEF 7.1"
    MOM_output_literal "CYCL DEF 7.2"
    MOM_output_literal "CYCL DEF 7.3"
    MOM_output_literal "L Z0.0 F MAX M92"
    MOM_output_literal "L X0.0 Y0.0 F MAX M92"
    MOM_output_literal "CYCL DEF 7.0"
    MOM_output_literal "CYCL DEF 7.1 #1"
    MOM_output_literal "CYCL DEF 7.0"
    MOM_output_literal "CYCL DEF 7.1 X$X"
    MOM_output_literal "CYCL DEF 7.2 Y$Y"
    MOM_output_literal "CYCL DEF 7.3 Z$Z"
    MOM_output_literal "CYCL DEF 19.0"
    MOM_output_literal "CYCL DEF 19.1 A$A B$B C$C"
    MOM_output_literal "L B+Q121 C+Q122 F MAX"
    MOM_output_literal "LBL 0"

} elseif {$type == "mazatrol"} {
#
#  This is only valid on an Integrex type B axis.  The A and C axes
#  cannot be used.
#
    if {![EQ_is_equal $A 0.0] || ![EQ_is_equal $C 0.0]} {
        global mom_warning_info
        set mom_warning_info "Invalid coordinate system.  Unable to configure G125 blocks."
        MOM_catch_warning
    } elseif {![EQ_is_equal $B 0.0]} {
        MOM_output_literal "G125 X$X Y$Y Z$Z B$B R1 S0"
    }
}}
}
}


#=============================================================
proc PB_CMD_init_rotary { } {
#=============================================================
uplevel #0 {

#
# Fourth and Fifth Axis Auto Clamping is activated by programming the
# UDE CLAMP/AUTO,ON in your tool path.  Fourth and Fifth Axis Auto
# Clamping may be turned off by programming the UDE CLAMP/AUTO,OFF.
#
# An M10 will be output to clamp the XYZ axis for fourth axis
# motion. An M11 will be output to un-clamp the fourth axis
# when fourth axis motion occurs in the block.  You may edit
# the custom commands PB_CMD_clamp_fourth_axis or
# PB_CMD_unclamp_fourth_axis to output codes other than M10 or M11.
# The same is true for the fifth axis except you must edit the custom
# commands PB_CMD_clamp_fifth_axis or PB_CMD_unclamp_fifth_axis.  If you
# have a five axis machine tool and only want fourth or fifth axis auto
# clamping, you will need to comment out the line that outputs the unneed
# code
#
#
# Retract and Re-Engage Parameters
#
# This option is activated by setting the Axis Limit Violation
# Handling option on the Machine Tool dialog to Retract / Re-Engage.
#
# The sequence of actions that take place when a rotary limit violation
# occurs is a retract to the clearance plane at the rapid feedrate,
# reposition the rotary axes so they do not violate, move back to
# the engage point at the retract feedrate and engage into the part again.
#
# You can set additional parameters that will control the retract
# and re-engage motion.
#
# The parameter "mom_kin_retract_plane" defines the distance
# from the center of rotation that the tool will retract when
# an axis violation occurs.  For a four axis head machine tool the
# retraction will be a cylinder.  For a five axis head machine tool
# the retraction will be to a sphere. For rotary tables the
# retraction will be to a plane along the spindle axis.
#

set mom_kin_retract_plane                      10.0


#
# The parameter "mom_kin_reengage_distance" defines the engage
# point above the part.
#

set mom_kin_reengage_distance                  .1


#
# The following parameters are used by UG Post.  Do NOT change
# them unless you know what you are doing.
#

set mom_kin_spindle_axis(0)                    0.0
set mom_kin_spindle_axis(1)                    0.0
set mom_kin_spindle_axis(2)                    1.0

if [info exists mom_sys_spindle_axis] { unset mom_sys_spindle_axis }

set mom_sys_spindle_axis(0)                    0.0
set mom_sys_spindle_axis(1)                    0.0
set mom_sys_spindle_axis(2)                    1.0

set mom_sys_lock_status                        "OFF"

} ;# uplevel
}


#=============================================================
proc PB_CMD_kin_before_motion { } {
#=============================================================
#
#  This custom command is used by UG Post to support Set/Lock,
#  rotary axis limit violation retracts and auto clamping.
#  Do not change this procedure.  If you want to improve
#  performance, you may comment out any of these procedures.
#

   global mom_kin_machine_type

   if [info exists mom_kin_machine_type] {
      if { [string match "*3_axis_mill*" $mom_kin_machine_type] ||  [string match "*lathe*" $mom_kin_machine_type] } {
return
      }
   }


   LOCK_AXIS_MOTION

   ROTARY_AXIS_RETRACT

   AUTO_CLAMP
}


#=============================================================
proc PB_CMD_kin_end_of_path { } {
#=============================================================
  # Record tool time for this operation.
   if [llength [info commands PB_CMD_set_oper_tool_time] ] {
      PB_CMD_set_oper_tool_time
   }
}


#=============================================================
proc PB_CMD_kin_feedrate_set { } {
#=============================================================
# This procedure supercedes the functionalites provided by the
# FEEDRATE_SET in ugpost_base.tcl.  Post Builder automatically
# generates proper call sequences to this procedure in the
# Event handlers.
#
# This procedure must be used in conjunction with ugpost_base.tcl.
#
  global   feed com_feed_rate
  global   mom_feed_rate_output_mode super_feed_mode feed_mode
  global   mom_cycle_feed_rate_mode mom_cycle_feed_rate
  global   mom_cycle_feed_rate_per_rev
  global   mom_motion_type
  global   mom_warning_info
  global   Feed_IPM Feed_IPR Feed_MMPM Feed_MMPR Feed_INV
  global   mom_sys_feed_param
  global   mom_sys_cycle_feed_mode

#  MOM_output_literal " feed_mode $feed_mode"


  set super_feed_mode $mom_feed_rate_output_mode
# MOM_output_literal " super_feed_mode $super_feed_mode"

  set f_pm [ASK_FEEDRATE_FPM] ; set f_pr [ASK_FEEDRATE_FPR]

  switch $mom_motion_type {

    CYCLE {
# MOM_output_literal " 3333feed_mode $feed_mode"
      if [info exists mom_sys_cycle_feed_mode] {
         if { $mom_sys_cycle_feed_mode != "Auto" } {
            set mom_cycle_feed_rate_mode $mom_sys_cycle_feed_mode
         }
      }
      if {[hiset mom_cycle_feed_rate_mode]} { set super_feed_mode $mom_cycle_feed_rate_mode }
      if {[hiset mom_cycle_feed_rate]} { set f_pm $mom_cycle_feed_rate }
      if {[hiset mom_cycle_feed_rate_per_rev]} { set f_pr $mom_cycle_feed_rate_per_rev }
    }

    FROM -
    RETRACT -
    RETURN -
    LIFT -
    TRAVERSAL -
    GOHOME -
    GOHOME_DEFAULT -
    RAPID {
#      SUPER_FEED_MODE_SET RAPID
    }


    default {
      if {[EQ_is_zero $f_pm] && [EQ_is_zero $f_pr]} {
 #       SUPER_FEED_MODE_SET RAPID
      } else {
# MOM_output_literal " 44444feed_mode $feed_mode f_pm $f_pm  f_pr $f_pr $super_feed_mode"
#        SUPER_FEED_MODE_SET CONTOUR
# MOM_output_literal " 42424244feed_mode $feed_mode f_pm $f_pm  f_pr $f_pr $super_feed_mode"
      }
    }
  }
 # MOM_output_literal " 42424244feed_mode $feed_mode f_pm $f_pm  f_pr $f_pr $super_feed_mode"

  set feed_mode $super_feed_mode
# MOM_output_literal " 222222222222222feed_mode $feed_mode"

 # Adjust feedrate format per Post output unit again.
  global mom_kin_output_unit
  if { $mom_kin_output_unit == "IN" } {
     switch $feed_mode {
       MMPM {
         set feed_mode "IPM"
         CATCH_WARNING "Feedrate mode MMPM changed to IPM"
       }
       MMPR {
         set feed_mode "IPR"
         CATCH_WARNING "Feedrate mode MMPR changed to IPR"
       }
     }
  } else {
     switch $feed_mode {
       IPM {
         set feed_mode "MMPM"
         CATCH_WARNING "Feedrate mode IPM changed to MMPM"
       }
       IPR {
         set feed_mode "MMPR"
         CATCH_WARNING "Feedrate mode IPR changed to MMPR"
       }
     }
  }

#  MOM_output_literal " 11111111111111 feed_mode $feed_mode"
  switch $feed_mode {
    IPM     -
    MMPM    { set feed $f_pm }
    IPR     -
    MMPR    { set feed $f_pr }
    DPM     { set feed [PB_CMD_FEEDRATE_DPM] }
    FRN     -
    INVERSE { set feed [PB_CMD_FEEDRATE_NUMBER] }
    default { set mom_warning_info "INVALID FEED RATE MODE" ; MOM_catch_warning ; return }
  }


 # Post Builder provided format for the current mode:
  if [info exists mom_sys_feed_param(${feed_mode},format)] {
    MOM_set_address_format F $mom_sys_feed_param(${feed_mode},format)
  } else {
    switch $feed_mode {
      IPM     -
      MMPM    -
      IPR     -
      MMPR    -
      DPM     -
      FRN     -
      INVERSE { MOM_set_address_format F Feed_INV }
    }
  }

 # Commentary output
  set com_feed_rate $f_pm
#  MOM_output_literal " feed_mode $feed_mode f_pm $f_pm  f_pr $f_pr"

 # Execute user's commnad, if any.
  if [llength [info commands "PB_CMD_FEEDRATE_SET"]] {
     PB_CMD_FEEDRATE_SET
  }
}


#=============================================================
proc PB_CMD_kin_init_mill_turn { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_init_mill_xzc { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_init_rotary { } {
#=============================================================

   global mom_kin_machine_type

   if [info exists mom_kin_machine_type] {
      if { [string match "*3_axis_mill*" $mom_kin_machine_type] ||  [string match "*lathe*" $mom_kin_machine_type] } {
return
      }
   }


   PB_CMD_init_rotary



uplevel #0 {


#=============================================================
proc MOM_clamp { } {
#=============================================================
  global mom_clamp_axis mom_clamp_status mom_sys_auto_clamp

   if {$mom_clamp_axis == "AUTO"} {
      if {$mom_clamp_status == "ON"} {
         set mom_sys_auto_clamp "ON"
      } elseif {$mom_clamp_status == "OFF"} {
         set mom_sys_auto_clamp "OFF"
      }
   }
}

#=============================================================
proc MOM_rotate { } {
#=============================================================
  global mom_rotate_axis_type mom_rotation_mode mom_rotation_direction
  global mom_rotation_angle mom_rotation_reference_mode
  global mom_kin_machine_type mom_kin_4th_axis_direction mom_kin_5th_axis_direction
  global mom_kin_4th_axis_leader mom_kin_5th_axis_leader
  global mom_kin_4th_axis_leader mom_kin_5th_axis_leader mom_pos
  global mom_out_angle_pos mom_prev_out_angle_pos
  global mom_prev_pos mom_sys_leader

   if {![info exists mom_rotation_angle]} {return}

  #
  #  Determine which axis the user wanted, fourth or fifth.
  #
   switch $mom_rotate_axis_type {
      AAXIS {
         set axis [AXIS_SET $mom_rotate_axis_type]
      }
      BAXIS {
         set axis [AXIS_SET $mom_rotate_axis_type]
      }
      CAXIS {
         set axis [AXIS_SET $mom_rotate_axis_type]
      }
      TABLE {
         set axis 3
      }
      HEAD {
         if { $mom_kin_machine_type == "5_axis_head_table ||  $mom_kin_machine_type == "5_AXIS_HEAD_TABLE" } {
            set axis 4
         } else {
            set axis 3
         }
      }
      default {
         set axis 3
      }
   }

   switch $mom_rotation_mode {
      NONE {
         set angle $mom_rotation_angle
         set mode 0
      }
      ATANGLE {
         set angle $mom_rotation_angle
         set mode 0
      }
      ABSOLUTE {
         set angle $mom_rotation_angle
         set mode 1
      }
      INCREMENTAL {
         set angle [expr $mom_pos($axis) + $mom_rotation_angle]
         set mode 0
      }
   }
   switch $mom_rotation_direction {
      NONE {
         set dir 0
      }
      CLW {
         set dir 1
      }
      CCLW {
         set dir -1
      }
   }

   set ang [LIMIT_ANGLE $angle]
   set mom_pos($axis) $ang


   if {$axis == "3" && ![info exists mom_prev_out_angle_pos(0)]} {
      set mom_prev_out_angle_pos(0) [MOM_ask_address_value fourth_axis]
      if {$mom_prev_out_angle_pos(0) == ""} {set mom_prev_out_angle_pos(0) 0.0}
   }


   if {$axis == "4" && ![info exists mom_prev_out_angle_pos(1)]} {
      set mom_prev_out_angle_pos(1) [MOM_ask_address_value fifth_axis]
      if {$mom_prev_out_angle_pos(1) == ""} {set mom_prev_out_angle_pos(1) 0.0}
   }

   set p [expr $axis + 1]
   set a [expr $axis - 3]
   if {$axis == "3" && $mom_kin_4th_axis_direction == "MAGNITUDE_DETERMINES_DIRECTION"} {
      set dirtype 0
   } elseif { $axis == "4" &&  $mom_kin_5th_axis_direction == "MAGNITUDE_DETERMINES_DIRECTION" } {
      set dirtype 0
   } else {
      set dirtype 1
   }

   if {$mode == 1} {
      set mom_out_angle_pos($a) $angle
   } elseif {$dirtype == 0} {

      if {$axis == 3} {
         set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(0) $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
      } else {
         set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(1) $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)]
      }

      if {$axis == 3} {set prot $mom_prev_out_angle_pos(0)}
      if {$axis == 4} {set prot $mom_prev_out_angle_pos(1)}
      if {$dir == 1 && $mom_out_angle_pos($a) < $prot} {
         set mom_out_angle_pos($a) [expr $mom_out_angle_pos($a) + 360.0]
      } elseif {$dir == -1 && $mom_out_angle_pos($a) > $prot} {
         set mom_out_angle_pos($a) [expr $mom_out_angle_pos($a) - 360.0]
      }
   } elseif {$dirtype == "1"} {

      if {$dir == -1} {
         if {$axis == 3} {
            set mom_sys_leader(fourth_axis) $mom_kin_4th_axis_leader-
         } else {
            set mom_sys_leader(fifth_axis) $mom_kin_5th_axis_leader-
         }
      } elseif {$dir == 0} {
         if {$axis == 3} {
            set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(0) $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
         } else {
            set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(1) $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)]
         }
      } elseif {$dir == 1} {
         set mom_out_angle_pos($a) $ang
      }
   }

   if {$axis == 3} {
#      PB_CMD_fourth_axis_rotate_move
   } else {
#      PB_CMD_fifth_axis_rotate_move
   }

   set mom_prev_pos($axis) $ang
   MOM_reload_variable -a mom_prev_pos
   MOM_reload_variable -a mom_out_angle_pos
}

#=============================================================
proc MOM_lock_axis { } {
#=============================================================
  global mom_sys_lock_value mom_sys_lock_plane
  global mom_sys_lock_axis mom_sys_lock_status

   set status [SET_LOCK axis plane value]
   if {$status == "error"} {
      MOM_catch_warning
      set mom_sys_lock_status OFF
   } else {
      set mom_sys_lock_status $status
      if {$status != "OFF"} {
         set mom_sys_lock_axis $axis
         set mom_sys_lock_plane $plane
         set mom_sys_lock_value $value
      }
   }
}

#=============================================================
proc PB_catch_warning { } {
#=============================================================
  global mom_sys_rotary_error mom_warning_info

   if {$mom_warning_info == "ROTARY CROSSING LIMIT."} {
      set mom_sys_rotary_error $mom_warning_info
   }
   if {$mom_warning_info == "secondary rotary position being used"} {
      set mom_sys_rotary_error $mom_warning_info
   }
}


} ;# uplevel
}


#=============================================================
proc PB_CMD_kin_linearize_motion { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_set_csys { } {
#=============================================================
   if [llength [info commands PB_CMD_set_csys] ] {
      PB_CMD_set_csys
   }
}


#=============================================================
proc PB_CMD_kin_start_of_path { } {
#=============================================================
#
#  This procedure is executed at the start of every operation.
#  It will check to see if a new head (post) was loaded and
#  will then initialize any functionality specific to that post.
#
#  It will also restore the initial Start of Program or End
#  of program event procedures.
#
#  DO NOT CHANGE THIS FILE UNLESS YOU KNOW WHAT YOU ARE DOING.
#  DO NOT CALL THIS PROCEDURE FROM ANY OTHER CUSTOM COMMAND.
#
  global mom_sys_head_change_init_program

   if [info exists mom_sys_head_change_init_program] {

      PB_CMD_kin_start_of_program
      unset mom_sys_head_change_init_program


     #<06-17-03 gsl> Moved from MOM_head to
     # execute start of head callback in new post's context.
      global CURRENT_HEAD
      if { [info exists CURRENT_HEAD] &&  [llength [info commands PB_start_of_HEAD__$CURRENT_HEAD]] } {
         PB_start_of_HEAD__$CURRENT_HEAD
      }

      # Restore master start & end of program handlers
      if [llength [info commands "MOM_start_of_program_save"]] {
         if [llength [info commands "MOM_start_of_program"]] {
            rename MOM_start_of_program ""
         }
         rename MOM_start_of_program_save MOM_start_of_program
      }
      if [llength [info commands "MOM_end_of_program_save"]] {
         if [llength [info commands "MOM_end_of_program"]] {
            rename MOM_end_of_program ""
         }
         rename MOM_end_of_program_save MOM_end_of_program
      }

     # Restore master head change event handler
      if [llength [info commands "MOM_head_save"]] {
         if [llength [info commands "MOM_head"]] {
            rename MOM_head ""
         }
         rename MOM_head_save MOM_head
      }
   }

  # Initialize tool time accumulator for this operation.
   if [llength [info commands -] ] {
      PB_CMD_init_oper_tool_time
   }

  # Force out motion G code at the start of path.
   MOM_force once G_motion
}


#=============================================================
proc PB_CMD_kin_start_of_program { } {
#=============================================================
#
#  This procedure will execute the following custom commands for
#  initialization.  They will be executed once at the start of
#  program and again each time they are loaded as a linked post.
#  After execution they will be deleted so that they are not
#  present when a different post is loaded.  You may add a call
#  to a procedure that you want executed when a linked post is
#  loaded.
#
#  Note that when a linked post is called in, the Start of Program
#  event marker is not executed again, neither is this procedure.
#
#  DO NOT REMOVE ANY LINES FROM THIS PROCEDURE UNLESS YOU KNOW
#  WHAT YOU ARE DOING.  DO NOT CALL THIS PROCEDURE FROM ANY
#  OTHER CUSTOM COMMAND.
#
   global mom_kin_machine_type


   set command_list [list]

   if [info exists mom_kin_machine_type] {
      if { ![string match "*3_axis_mill*" $mom_kin_machine_type] &&  ![string match "*lathe*" $mom_kin_machine_type] } {

         lappend command_list  PB_CMD_kin_init_rotary
      }
   }

   lappend command_list  PB_CMD_init_pivot_offsets
   lappend command_list  PB_CMD_init_auto_retract
   lappend command_list  PB_CMD_initialize_parallel_zw_mode
   lappend command_list  PB_CMD_init_parallel_zw_mode
   lappend command_list  PB_CMD_initialize_tool_list
   lappend command_list  PB_CMD_init_tool_list
   lappend command_list  PB_CMD_init_tape_break
   lappend command_list  PB_CMD_initialize_spindle_axis
   lappend command_list  PB_CMD_init_spindle_axis
   lappend command_list  PB_CMD_initialize_helix
   lappend command_list  PB_CMD_init_helix
   lappend command_list  PB_CMD_pq_cutcom_initialize
   lappend command_list  PB_CMD_init_pq_cutcom

   if [info exists mom_kin_machine_type] {
      if { [string match "*3_axis_mill_turn*" $mom_kin_machine_type] } {

          lappend command_list  PB_CMD_kin_init_mill_xzc
          lappend command_list  PB_CMD_kin_mill_xzc_init
          lappend command_list  PB_CMD_kin_init_mill_turn
          lappend command_list  PB_CMD_kin_mill_turn_initialize
      }
   }

   foreach cmd $command_list {

      if [llength [info commands "$cmd"]] {

         # <PB v2.0.2>
         # Old init commands for XZC/MILL_TURN posts are not executed.
         # Parameters set by these commands in the v2.0 legacy posts
         # will need to be transfered to PB_CMD_init_mill_xzc &
         # PB_CMD_init_mill_turn commands respectively.

         switch { $cmd } {
            "PB_CMD_kin_mill_xzc_init" -
            "PB_CMD_kin_mill_turn_initialize" {}
            default { $cmd }
         }
         rename $cmd ""
         proc $cmd { args } {}
      }
   }
}


#=============================================================
proc PB_CMD_linear_move { } {
#=============================================================
#
#  This procedure is used my many automatic postbuilder functions
#  to output a linear move.  Do NOT add this block to events or
#  markers.  It is a static block and it is not intended to be added
#  to events.  Do NOT change the name of this procedure.
#
#  If you need a custom command to be output with a linear move block,
#  you must place a call to the custom command either before or after
#  the MOM_do_template command.
#
#  This proc is used for:
#     simulated cycles feed moves
#     mill/turn mill linearization
#     four and five axis retract and re-engage
#

  MOM_do_template linear_move
}

#=============================================================
proc PB_CMD_init_helix { } {
#=============================================================
uplevel #0 {
#
# This procedure will be executed automatically at the start of program and
# anytime it is loaded as a slave post of a linked post.
#
# This procedure can be used to enable your post to output helix.
# You can choose from the following options to format the circle
# block template to output the helix parameters.
#

set mom_sys_helix_pitch_type	"other"

#
# The default setting for mom_sys_helix_pitch_type is "rise_radian".
# This is the most common.  Other choices are:
#
#    "rise_radian"              Measures the rise over one radian.
#    "rise_revolution"          Measures the rise over 360 degrees.
#    "none"                     Will suppress the output of pitch.
#    "other"                    Allows you to calculate the pitch
#                               using your own formula.
#
# This custom command uses the block template circular_move to output
# the helix block.  If your post uses a block template with a different
# name, you must edit the line that outputs the helix block.

#
#  The following variable deines the output mode for helical records.
#
#  FULL_CIRCLE  -- This mode will output a helix record for each 360
#                  degrees of the helix.
#  QUADRANT  --    This mode will output a helix record for each 90
#                  degrees of the helix.
#  LINEAR  --      This mode will output the entire helix as linear gotos.
#  END_POINT --    This mode will assume the control can define an entire
#                  helix in a single block.

   set mom_kin_helical_arc_output_mode END_POINT

   MOM_reload_kinematics



#=============================================================
proc MOM_helix_move { } {
#=============================================================
   global mom_pos_arc_plane
   global mom_sys_cir_vector
   global mom_sys_helix_pitch_type
   global mom_helix_pitch
   global mom_prev_pos mom_pos_arc_center mom_pos
   global PI PP P
#  MOM_output_literal "$mom_pos_arc_plane "
   switch $mom_pos_arc_plane {
      XY { MOM_suppress once K ; set cir_index 2 }
      YZ { MOM_suppress once I ; set cir_index 0 }
      ZX { MOM_suppress once J ; set cir_index 1 }
   }
    set cir_index 2
   switch $mom_sys_helix_pitch_type {
      none { }
      rise_revolution { set pitch $mom_helix_pitch }
      rise_radian { set pitch [expr $mom_helix_pitch / ($PI * 2.0)]}
      other {
#
	set pitch [expr $mom_helix_pitch/1]
#	Place your custom helix pitch code here
#
      }
      default { set mom_sys_helix_pitch_type "none" }
   }

   MOM_force once X Y Z
#  MOM_output_literal "$mom_sys_cir_vector "
   if {$mom_sys_helix_pitch_type != "none"} {
      MOM_force once I J K

      switch $mom_sys_cir_vector {
         "Vector - Arc Center to Start" {
            set mom_prev_pos($cir_index) $pitch
            set mom_pos_arc_center($cir_index) 0.0
         }
         "Vector - Arc Start to Center" {
	#if {$cir_index != 2} {
        #   set mom_prev_pos($cir_index) 0.0
        #   set mom_pos_arc_center($cir_index) $pitch
        # } elseif {$cir_index == 2}
 #         MOM_output_literal "$mom_prev_pos($cir_index) $mom_pos($cir_index)"
	set PP [expr ($mom_prev_pos($cir_index) - $mom_pos($cir_index))/$pitch]
	set P [expr int($PP)]
	MOM_suppress once K
	if {$PP < 0} {
	set PP [expr $PP*(-1)]
        set P [expr $P*(-1)]
	}
	#if {$PP > $P} {
	#set P [expr $P+1]
	}
#	  MOM_output_literal "$P"
	if {$P ==1} {
       MOM_suppress once P_cutcom
      } else {
        MOM_force once P_cutcom
	}
#	}
         "Unsigned Vector - Arc Center to Start" {
            set mom_prev_pos($cir_index) 0.0
            set mom_pos_arc_center($cir_index) $pitch
         }
         "Vector - Absolute Arc Center" {
            set mom_pos_arc_center($cir_index) $pitch
         }
      }
   }


#
# You may need to edit this line if you output more than one block
# or if you have changed the name of your circular_move block template
#
   MOM_do_template circular_move


} ;# MOM_helix_move


} ;# uplevel
}

#=============================================================
proc PB_CMD_linearize_motion { } {
#=============================================================
}


#=============================================================
proc PB_CMD_nurbs_end_of_program { } {
#=============================================================
  global nurbs_move_flag

  if {[info exists nurbs_move_flag]} {MOM_output_literal "G05 P0"}
}


#=============================================================
proc PB_CMD_nurbs_initialize { } {
#=============================================================
#
#  You will need to activate nurbs motion in Unigraphics CAM under
#  machine control to generate nurbs events.
#
#  This procedure is used to establish nurbs parameters.  It must be
#  placed in the Start of Program marker to output nurbs.
#
uplevel #0 {

  set mom_kin_nurbs_output_type              BSPLINE

  MOM_reload_kinematics

proc MOM_nurbs_move {} {
#_______________________________________________________________________________
# This procedure is executed for each nurbs move.
#_______________________________________________________________________________
  global mom_nurbs_knot_count
  global mom_nurbs_point_count
  global mom_nurbs_order

  global nurbs_knot_count
  global nurbs_precision
  global nurbs_move_flag
  global anchor_flag

  if {![info exists nurbs_move_flag]} {
      MOM_output_literal "G05 P10000"
      set nurbs_move_flag 1
  }

  FEEDRATE_SET
  if {![info exists anchor_flag]} {
      MOM_do_template anchor_point
      set anchor_flag 0
  }

  set nurbs_knot_count 0
  MOM_force once G_motion order X Y Z

  while {$nurbs_knot_count < $mom_nurbs_point_count} {
         MOM_do_template nurbs
         set nurbs_knot_count [expr $nurbs_knot_count + 1]
  }
  while {$nurbs_knot_count < $mom_nurbs_knot_count} {
         MOM_do_template knots
         set nurbs_knot_count [expr $nurbs_knot_count + 1]
  }
}




}
}


#=============================================================
proc PB_CMD_set_cycle_plane { } {
#=============================================================
# Use this command to set a proper cycle plane when G17/18/19
# is used in the cycle definition.

  global mom_cycle_spindle_axis mom_cutcom_plane mom_pos_arc_plane

   if [info exists mom_cycle_spindle_axis] {
      switch $mom_cycle_spindle_axis {
         0 {
            set mom_cutcom_plane  YZ
            set mom_pos_arc_plane YZ
         }
         1 {
            set mom_cutcom_plane  ZX
            set mom_pos_arc_plane ZX
         }
         2 {
            set mom_cutcom_plane  XY
            set mom_pos_arc_plane XY
         }
         default {
            set mom_cutcom_plane  UNDEFINED
            set mom_pos_arc_plane UNDEFINED
         }
      }
   }
}


#=============================================================
proc PB_CMD_start_of_alignment_character { } {
#=============================================================
 # This command can be used to output a special sequence number character.
 # Replace the ":" with any character that you require.
 # You must use the command "PB_CMD_end_of_alignment_character" to reset
 # the sequence number back to the original setting.

  global mom_sys_leader saved_seq_num
  set saved_seq_num $mom_sys_leader(N)
  set mom_sys_leader(N) "N"
}


#=============================================================
proc PB_CMD_start_of_operation_force_addresses { } {
#=============================================================
  MOM_force once  X Y Z F R fifth_axis
}


#=============================================================
proc PB_CMD_tool_change_force_addresses { } {
#=============================================================
  MOM_force once G_adjust H
}


#=============================================================
proc PB_CMD_unclamp_fifth_axis { } {
#=============================================================
#
#  This procedure is used by auto clamping to output the code
#  needed to unclamp the fifth axis.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#
#  MOM_output_literal "M212"
}


#=============================================================
proc PB_CMD_unclamp_fourth_axis { } {
#=============================================================
#
#  This procedure is used by auto clamping to output the code
#  needed to unclamp the fourth axis.
#
#  Do NOT add this block to events or markers.  It is a static
#  block and it is not intended to be added to events.  Do NOT
#  change the name of this custom command.
#
#  MOM_output_literal "M11"
}


#=============================================================
proc DELAY_TIME_SET {  } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {set delay_time $mom_delay_revs}
    }
}


#=============================================================
proc EQ_is_zero { s } {
#=============================================================
   global mom_system_tolerance

   if [info exists mom_system_tolerance] {
      if { [expr abs($s)] <= $mom_system_tolerance } { return 1 } else { return 0 }
   } else {
      return 0
   }
}


#=============================================================
proc SOLVE_QUADRATIC { coeff rcomp icomp status degree } {
#=============================================================

  upvar $coeff c ; upvar $rcomp rc ; upvar $icomp ic
  upvar $status st ; upvar $degree deg

   set st 1
   set deg 0
   set rc(0) 0.0 ; set rc(1) 0.0
   set ic(0) 0.0 ; set ic(1) 0.0
   set mag [VEC3_mag c]
   if {[EQ_is_zero $mag]} {return 0}
   set acoeff [expr $c(2)/$mag]
   set bcoeff [expr $c(1)/$mag]
   set ccoeff [expr $c(0)/$mag]
   if {![EQ_is_zero $acoeff]} {
      set deg 2
      set denom [expr $acoeff*2.]
      set dscrm [expr $bcoeff*$bcoeff - $acoeff*$ccoeff*4.0]
      if {[EQ_is_zero $dscrm]} {
         set dsqrt1 0.0
      } else {
         set dsqrt1 [expr sqrt(abs($dscrm))]
      }
      if {[EQ_is_ge $dscrm 0.0]} {
         set rc(0) [expr (-$bcoeff + $dsqrt1)/$denom]
         set rc(1) [expr (-$bcoeff - $dsqrt1)/$denom]
         set st 3
         return 2
      } else {
         set rc(0) [expr -$bcoeff/$denom]
         set rc(1) $rc(0)
         set ic(0) [expr $dsqrt1/$denom]
         set ic(1) $ic(0)
         set st 2
         return 0
      }
   } elseif {![EQ_is_zero $bcoeff] } {
      set st 3
      set deg 1
      set rc(0) [expr -$ccoeff/$bcoeff]
      return 1
   } elseif {[EQ_is_zero $ccoeff] } {
      return 0
   } else {
      return 0
   }
}


#=============================================================
proc LOCK_AXIS_MOTION {  } {
#=============================================================
#
#  The UDE lock_axis must be specified in the tool path
#  for the post to lock the requested axis.  The UDE lock_axis may only
#  be used for four and five axis machine tools.  A four axis post may
#  only lock an axis in the plane of the fourth axis.  For five axis
#  posts only the fifth axis may be locked.  Five axis will only
#  output correctly if the fifth axis is rotated so it is perpendicular
#  to the spindle axis.
#
  global mom_pos mom_out_angle_pos mom_current_motion mom_motion_type
  global mom_cycle_feed_to_pos mom_cycle_feed_to mom_tool_axis
  global mom_motion_event mom_sys_lock_status
  global mom_cycle_rapid_to_pos mom_cycle_retract_to_pos
  global mom_cycle_rapid_to mom_cycle_retract_to
  global mom_prev_pos
  global mom_kin_4th_axis_type
  global mom_kin_spindle_axis
  global mom_kin_5th_axis_type
  global mom_kin_4th_axis_plane


  if {$mom_sys_lock_status == "ON"} {
    if {$mom_current_motion != "circular_move"} {
      LOCK_AXIS mom_pos mom_prev_pos mom_pos mom_out_angle_pos
      MOM_reload_variable -a mom_out_angle_pos
      MOM_reload_variable -a mom_pos
      if {$mom_motion_type == "CYCLE"} {
        if {$mom_motion_event == "initial_move"} {
           set mom_pos(0) [expr $mom_pos(0) - $mom_cycle_rapid_to * $mom_tool_axis(0)]
           set mom_pos(1) [expr $mom_pos(1) - $mom_cycle_rapid_to * $mom_tool_axis(1)]
           set mom_pos(2) [expr $mom_pos(2) - $mom_cycle_rapid_to * $mom_tool_axis(2)]
        }
        if {$mom_kin_4th_axis_type == "Table"} {
           VMOV 3 mom_kin_spindle_axis mom_sys_spindle_axis
        } elseif {$mom_kin_5th_axis_type == "Table"} {
           VMOV 3 mom_tool_axis vec
           if {$mom_kin_4th_axis_plane == "XY"} {
              set vec(2) 0.0
           } elseif {$mom_kin_4th_axis_plane == "ZX"} {
             set vec(1) 0.0
           } elseif {$mom_kin_4th_axis_plane == "YZ"} {
             set vec(0) 0.0
           }
           set l [VEC3_unitize vec mom_sys_spindle_axis]
           if {[EQ_is_zero l]} {
              set mom_sys_spindle_axis(2) 1.0
           }
        } else {
           VMOV 3 mom_tool_axis mom_sys_spindle_axis
        }

        set mom_cycle_feed_to_pos(0) [expr $mom_pos(0) + $mom_cycle_feed_to * $mom_sys_spindle_axis(0)]
        set mom_cycle_feed_to_pos(1) [expr $mom_pos(1) + $mom_cycle_feed_to * $mom_sys_spindle_axis(1)]
        set mom_cycle_feed_to_pos(2) [expr $mom_pos(2) + $mom_cycle_feed_to * $mom_sys_spindle_axis(2)]

        set mom_cycle_rapid_to_pos(0) [expr $mom_pos(0) + $mom_cycle_rapid_to * $mom_sys_spindle_axis(0)]
        set mom_cycle_rapid_to_pos(1) [expr $mom_pos(1) + $mom_cycle_rapid_to * $mom_sys_spindle_axis(1)]
        set mom_cycle_rapid_to_pos(2) [expr $mom_pos(2) + $mom_cycle_rapid_to * $mom_sys_spindle_axis(2)]

        set mom_cycle_retract_to_pos(0) [expr $mom_pos(0) + $mom_cycle_retract_to * $mom_sys_spindle_axis(0)]
        set mom_cycle_retract_to_pos(1) [expr $mom_pos(1) + $mom_cycle_retract_to * $mom_sys_spindle_axis(1)]
        set mom_cycle_retract_to_pos(2) [expr $mom_pos(2) + $mom_cycle_retract_to * $mom_sys_spindle_axis(2)]
      }
    }
  }
}


#=============================================================
proc LOCK_AXIS { input_point prev_point output_point output_rotary } {
#=============================================================
  upvar $input_point ip ; upvar $output_point op ; upvar $output_rotary or
  upvar $prev_point pp

  global mom_kin_4th_axis_center_offset mom_kin_5th_axis_center_offset
  global mom_kin_4th_axis_plane mom_kin_5th_axis_plane
  global mom_sys_lock_value mom_sys_lock_plane
  global mom_sys_lock_axis mom_sys_lock_status
  global mom_out_angle_pos mom_prev_out_angle_pos mom_kin_4th_axis_direction
  global mom_kin_5th_axis_direction mom_kin_4th_axis_leader mom_kin_5th_axis_leader
  global mom_sys_leader
  global DEG2RAD RAD2DEG


   if {$mom_sys_lock_status == "OFF"} {
      return
   }
   VEC3_sub ip mom_kin_4th_axis_center_offset temp
   if [info exists mom_kin_5th_axis_center_offset] {
      VEC3_sub temp mom_kin_5th_axis_center_offset temp
   }
   set temp(3) $ip(3)
   set temp(4) $ip(4)

   if {$mom_sys_lock_plane == -1} {
      if {$mom_kin_4th_axis_plane == "XY"} {
         set mom_sys_lock_plane 2
      } elseif {$mom_kin_4th_axis_plane == "ZX"} {
         set mom_sys_lock_plane 1
      } elseif {$mom_kin_4th_axis_plane == "YZ"} {
         set mom_sys_lock_plane 0
      }
   }

   if {$mom_kin_4th_axis_plane == "XY"} {
      set fourth_axis 2
   } elseif {$mom_kin_4th_axis_plane == "ZX"} {
      set fourth_axis 1
   } elseif {$mom_kin_4th_axis_plane == "YZ"} {
      set fourth_axis 0
   }

   if {[info exists mom_kin_5th_axis_plane]} {
      if {$mom_kin_5th_axis_plane == "XY"} {
         set fifth_axis 2
      } elseif {$mom_kin_5th_axis_plane == "ZX"} {
         set fifth_axis 1
      } elseif {$mom_kin_5th_axis_plane == "YZ"} {
         set fifth_axis 0
      }
   } else {
      set fifth_axis -1
   }


   if {$mom_sys_lock_axis > 2} {
      set angle [expr ($mom_sys_lock_value-$temp($mom_sys_lock_axis))*$DEG2RAD]
      ROTATE_VECTOR $mom_sys_lock_plane $angle temp temp1
      VMOV 3 temp1 temp
      set temp($mom_sys_lock_axis) $mom_sys_lock_value
   } else {
      if {$mom_sys_lock_plane == 0} {
         set i1 1
         set i2 2
      } elseif {$mom_sys_lock_plane == 1} {
         set i1 2
         set i2 0
      } elseif {$mom_sys_lock_plane == 2} {
         set i1 0
         set i2 1
      }
      set unlocked_axis [expr $i1 + $i2 - $mom_sys_lock_axis]
      set rad [expr sqrt($temp($i1)*$temp($i1) + $temp($i2)*$temp($i2))]
      set angle [ARCTAN $temp($i2) $temp($i1)]
      if { $rad < [expr abs($mom_sys_lock_value)]} {
         if {$mom_sys_lock_value < 0.0} {
            set temp($mom_sys_lock_axis) [expr -$rad]
         } else {
            set temp($mom_sys_lock_axis) $rad
         }
      } else {
         set temp($mom_sys_lock_axis) $mom_sys_lock_value
      }

      set temp($unlocked_axis)  [expr sqrt($rad*$rad - $temp($mom_sys_lock_axis)*$temp($mom_sys_lock_axis))]

         VMOV 5 temp temp1
         set temp1($unlocked_axis) [expr -$temp($unlocked_axis)]
         set ang1 [ARCTAN $temp($i2) $temp($i1)]
         set ang2 [ARCTAN $temp1($i2) $temp1($i1)]
         if {$fifth_axis == -1} {
            set i1 3
         } else {
            set i1 4
         }
         set temp($i1) [expr ($angle-$ang1)*$RAD2DEG]
         set temp1($i1) [expr ($angle-$ang2)*$RAD2DEG]
         set ang1 [LIMIT_ANGLE [expr $pp($i1)-$temp($i1)]]
         set ang2 [LIMIT_ANGLE [expr $pp($i1)-$temp1($i1)]]
         VEC3_sub temp pp v1
         set d1 [VEC3_mag v1]
         VEC3_sub temp1 pp v1
         set d2 [VEC3_mag v1]
         if {$ang1 > 180.0} {set ang1 [LIMIT_ANGLE [expr -$ang1]]}
         if {$ang2 > 180.0} {set ang2 [LIMIT_ANGLE [expr -$ang2]]}
         if {$d1 > $d2} {VMOV 5 temp1 temp}
   }

   VEC3_add temp mom_kin_4th_axis_center_offset op
   if {[info exists mom_kin_5th_axis_center_offset]} {
      VEC3_add op mom_kin_5th_axis_center_offset op
   }

   if {![info exists or]} {
      set or(0) 0.0
      set or(1) 0.0
   }
   if {![info exists mom_prev_out_angle_pos]} {
      set mom_prev_out_angle_pos(0) $or(0)
      set mom_prev_out_angle_pos(1) $or(1)
   }

   set or(0) [ROTSET $temp(3) $mom_prev_out_angle_pos(0) $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
   if {[info exists mom_kin_5th_axis_direction]} {
      set or(1) [ROTSET $temp(4) $mom_prev_out_angle_pos(1) $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)]
   }
   set op(3) $temp(3)
   set op(4) $temp(4)
}


#=============================================================
proc VMOV { n p1 p2 } {
#=============================================================
  upvar $p1 v1 ; upvar $p2 v2

   for {set i 0} {$i < $n} {incr i} {
      set v2($i) $v1($i)
   }
}


#=============================================================
proc LOCK_AXIS_SUB { axis } {
#=============================================================
  global mom_pos mom_lock_axis_value_defined mom_lock_axis_value

   if {$mom_lock_axis_value_defined == 1} {
      return $mom_lock_axis_value
   } else {
      return $mom_pos($axis)
   }
}


#=============================================================
proc REPOSITION_ERROR_CHECK { warn } {
#=============================================================
  global mom_kin_4th_axis_max_limit mom_kin_4th_axis_min_limit
  global mom_kin_5th_axis_max_limit mom_kin_5th_axis_min_limit
  global mom_pos mom_prev_pos mom_alt_pos mom_alt_prev_pos
  global mom_sys_rotary_error mom_warning_info mom_kin_machine_type

  if {$warn != "secondary rotary position being used" || [string index $mom_kin_machine_type 0] != 5} {
    set mom_sys_rotary_error $warn
    return
  }

  set mom_sys_rotary_error 0

  set a4 [expr $mom_alt_pos(3)+360.0]
  set a5 [expr $mom_alt_pos(4)+360.0]
  while {[expr $a4-$mom_kin_4th_axis_min_limit] > 360.0} {set a4 [expr $a4-360.0]}
  while {[expr $a5-$mom_kin_5th_axis_min_limit] > 360.0} {set a5 [expr $a5-360.0]}
  if {$a4 <= $mom_kin_4th_axis_max_limit && $a5 <= $mom_kin_5th_axis_max_limit} {return}

  for {set i 0} {$i < 2} {incr i} {
    set rot($i) [expr $mom_pos([expr $i+3]) - $mom_prev_pos([expr $i+3])]
    while {$rot($i) > 180.0} {set rot($i) [expr $rot($i)-360.0]}
    while {$rot($i) < 180.0} {set rot($i) [expr $rot($i)+360.0]}
    set rot($i) [expr abs($rot($i))]

    set rotalt($i) [expr $mom_alt_pos([expr $i+3]) - $mom_prev_pos([expr $i+3])]
    while {$rotalt($i) > 180.0} {set rotalt($i) [expr $rotalt($i)-360.0]}
    while {$rotalt($i) < 180.0} {set rotalt($i) [expr $rotalt($i)+360.0]}
    set rotalt($i) [expr abs($rotalt($i))]
  }

  if {[EQ_is_equal [expr $rot(0)+$rot(1)] [expr $rotalt(0)+$rotalt(1)]]} {return}
  set mom_sys_rotary_error $warn
}


#=============================================================
proc CATCH_WARNING { msg } {
#=============================================================
  global mom_warning_info
  global mom_motion_event
  global mom_event_number

   set level [info level]
   set call_stack ""
   for {set i 1} {$i < $level} {incr i} {
      set call_stack "$call_stack\[ [lindex [info level $i] 0] \]"
   }
   set mom_warning_info "$msg ($mom_motion_event $mom_event_number) $call_stack"
   MOM_catch_warning
}


#=============================================================
proc AXIS_SET { axis } {
#=============================================================

  global mom_sys_leader

   if {$axis == "[string index $mom_sys_leader(fourth_axis) 0]AXIS"} {
      return 3
   } elseif {$axis == "[string index $mom_sys_leader(fifth_axis) 0]AXIS"} {
      return 4
   }
}


#=============================================================
proc WORKPLANE_SET {  } {
#=============================================================
   global mom_cycle_spindle_axis
   global mom_sys_spindle_axis
   global traverse_axis1 traverse_axis2

   if { ![info exists mom_sys_spindle_axis] } {
      set mom_sys_spindle_axis(0) 0.0
      set mom_sys_spindle_axis(1) 0.0
      set mom_sys_spindle_axis(2) 1.0
   }

   if { ![info exists mom_cycle_spindle_axis] } {
      set x $mom_sys_spindle_axis(0)
      set y $mom_sys_spindle_axis(1)
      set z $mom_sys_spindle_axis(2)

      if { [EQ_is_zero $y] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 0
      } elseif { [EQ_is_zero $x] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 1
      } else {
         set mom_cycle_spindle_axis 2
      }
   }

   if { $mom_cycle_spindle_axis == 2 } {
      set traverse_axis1 0 ; set traverse_axis2 1
   } elseif { $mom_cycle_spindle_axis == 0 } {
      set traverse_axis1 1 ; set traverse_axis2 2
   } elseif { $mom_cycle_spindle_axis == 1 } {
      set traverse_axis1 0 ; set traverse_axis2 2
   }
}


#=============================================================
proc EQ_is_equal { s t } {
#=============================================================
   global mom_system_tolerance

   if [info exists mom_system_tolerance] {
      if { [expr abs($s - $t)] <= $mom_system_tolerance } { return 1 } else { return 0 }
   } else {
      return 0
   }
}


#=============================================================
proc SET_LOCK { axis plane value } {
#=============================================================
  upvar $axis a ; upvar $plane p ; upvar $value v

  global mom_kin_machine_type mom_lock_axis mom_lock_axis_plane mom_lock_axis_value
  global mom_warning_info

   switch $mom_kin_machine_type {
      4_axis_head -
      4_AXIS_HEAD -
      4_axis_table -
      4_AXIS_TABLE -
      mill_turn -
      MILL_TURN            {set mtype 4}
      5_axis_dual_table -
      5_AXIS_DUAL_TABLE -
      5_axis_dual_head -
      5_AXIS_DUAL_HEAD -
      5_axis_head_table -
      5_AXIS_HEAD_TABLE    {set mtype 5}
      default {
         set mom_warning_info "Set lock only vaild for 4 and 5 axis machines"
         return "error"
      }
   }

   set p -1

   switch $mom_lock_axis {
      OFF {
         return "OFF"
      }
      XAXIS {
         set a 0
         switch $mom_lock_axis_plane {
            XYPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 2
            }
            YZPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            ZXPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 1
            }
            NONE {
               if {$mtype == 5} {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }
      }
      YAXIS {
         set a 1
         switch $mom_lock_axis_plane {
            XYPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 2
            }
            YZPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 0
            }
            ZXPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            NONE {
               if {$mtype == 5} {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }
      }
      ZAXIS {
         set a 2
         switch $mom_lock_axis_plane {
            YZPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 0
            }
            ZXPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 1
            }
            XYPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            NONE {
               if {$mtype == 5} {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }
      }
      FOURTH {
         set a 3
         set v [LOCK_AXIS_SUB $a]
      }
      FIFTH {
         set a 4
         set v [LOCK_AXIS_SUB $a]
      }
      AAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
      BAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
      CAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
   }

return "ON"
}


#=============================================================
proc AUTO_CLAMP {  } {
#=============================================================
#
#  This procedure is used to automatically output clamp and unclamp
#  codes.  This procedure must be placed in the the procedure
#  << PB_CMD_kin_before_motion >>.  By default this procedure will
#  output M10 or M11 to do fourth axis clamping and unclamping or
#  M12 or M13 to do fifth axis clamping and unclamping.
#
   global clamp_rotary_fourth_status
   global clamp_rotary_fifth_status
   global mom_pos
   global mom_prev_pos
   global mom_sys_auto_clamp
   global mom_kin_machine_type

   if {![info exists mom_sys_auto_clamp]} {return}
   if {$mom_sys_auto_clamp != "ON"} {return}

   if {![info exists clamp_rotary_fourth_status]} {set clamp_rotary_fourth_status "UNDEFINED"}
   if {![info exists clamp_rotary_fifth_status]} {set clamp_rotary_fifth_status "UNDEFINED"}

   set rotary_out [EQ_is_equal $mom_pos(3) $mom_prev_pos(3)]

   if {$rotary_out  == 0 && $clamp_rotary_fourth_status != "UNCLAMPED"} {
      PB_CMD_unclamp_fourth_axis
      set clamp_rotary_fourth_status "UNCLAMPED"
   } elseif {$rotary_out == 1 && $clamp_rotary_fourth_status != "CLAMPED"} {
      PB_CMD_clamp_fourth_axis
      set clamp_rotary_fourth_status "CLAMPED"
   }

   switch $mom_kin_machine_type {
      5_axis_dual_table -
      5_AXIS_DUAL_TABLE -
      5_axis_dual_head -
      5_AXIS_DUAL_HEAD -
      5_axis_head_table -
      5_AXIS_HEAD_TABLE {}
      default           {return}
    }

   set rotary_out [EQ_is_equal $mom_pos(4) $mom_prev_pos(4)]

   if {$rotary_out  == 0 && $clamp_rotary_fifth_status != "UNCLAMPED"} {
      PB_CMD_unclamp_fifth_axis
      set clamp_rotary_fifth_status "UNCLAMPED"
   } elseif {$rotary_out == 1 && $clamp_rotary_fifth_status != "CLAMPED"} {
      PB_CMD_clamp_fifth_axis
      set clamp_rotary_fifth_status "CLAMPED"
   }
}


#=============================================================
proc ARCTAN { y x } {
#=============================================================
   global PI

   if [EQ_is_zero $y] { set y 0 }
   if [EQ_is_zero $x] { set x 0 }

   set ang [expr atan2($y,$x)]

   if { $ang < 0 } {
      return [expr $ang + $PI*2]
   } else {
      return $ang
   }
}




#=============================================================
proc CALC_SPHERICAL_RETRACT_POINT { refpt axis cen_sphere rad_sphere int_pts } {
#=============================================================

  upvar $refpt rp ; upvar $axis ta ; upvar $cen_sphere cs
  upvar $int_pts ip

   set rad [expr $rad_sphere*$rad_sphere]
   VEC3_sub rp cs v1

   set coeff(2) 1.0
   set coeff(1) [expr ($v1(0)*$ta(0) + $v1(1)*$ta(1) + $v1(2)*$ta(2))*2.0]
   set coeff(0) [expr $v1(0)*$v1(0) + $v1(1)*$v1(1) + $v1(2)*$v1(2) - $rad]

   set num_sol [SOLVE_QUADRATIC coeff roots iroots status degree]
   if {$num_sol == 0} {return 0}

   if {[expr $roots(0)] > [expr $roots(1)] || $num_sol == 1} {
      set d $roots(0)
   } else {
      set d $roots(1)
   }
   set ip(0) [expr $rp(0) + $d*$ta(0)]
   set ip(1) [expr $rp(1) + $d*$ta(1)]
   set ip(2) [expr $rp(2) + $d*$ta(2)]

return [RETRACT_POINT_CHECK rp ta ip]
}






#=============================================================
proc CALC_CYLINDRICAL_RETRACT_POINT { refpt axis dist ret_pt } {
#=============================================================
  upvar $refpt rfp ; upvar $axis ax ; upvar $ret_pt rtp

#
# return 0 parallel or lies on plane
#        1 unique intersection
#


#
# create plane canonical form
#
  VMOV 3 ax plane
  set plane(3) $dist

  set num [expr $plane(3)-[VEC3_dot rfp plane]]
  set dir [VEC3_dot ax plane]
  if {[EQ_is_zero $dir]} {return 0}
  for {set i 0} {$i < 3} {incr i} {
    set rtp($i) [expr $rfp($i) + $ax($i)*$num/$dir]
  }
  return [RETRACT_POINT_CHECK rfp ax rtp]
}


#=============================================================
proc ROTATE_VECTOR { plane angle input_vector output_vector } {
#=============================================================
  upvar $output_vector v ; upvar $input_vector v1

   if {$plane == 0} {
      set v(0) $v1(0)
      set v(1) [expr $v1(1)*cos($angle) - $v1(2)*sin($angle)]
      set v(2) [expr $v1(2)*cos($angle) + $v1(1)*sin($angle)]
   } elseif {$plane == 1} {
      set v(0) [expr $v1(0)*cos($angle) + $v1(2)*sin($angle)]
      set v(1) $v1(1)
      set v(2) [expr $v1(2)*cos($angle) - $v1(0)*sin($angle)]
   } elseif {$plane == 2} {
      set v(0) [expr $v1(0)*cos($angle) - $v1(1)*sin($angle)]
      set v(1) [expr $v1(1)*cos($angle) + $v1(0)*sin($angle)]
      set v(2) $v1(2)
   }
}


#=============================================================
proc RETRACT_POINT_CHECK { refpt axis retpt } {
#=============================================================
  upvar $refpt rfp ; upvar $axis ax ; upvar $retpt rtp

#
#  determine if retraction point is "below" the retraction plane
#  if the tool is already in a safe position, do not retract
#
#  return 0	no retract needed
#         1     retraction needed
#

  VEC3_sub rtp rfp vec
  if {[VEC3_is_zero vec]} {return 0}
  set x [VEC3_unitize vec vec1]
  set dir [VEC3_dot ax vec1]
  if {$dir <= 0.0} {
    return 0
  } else {
    return 1
  }
}


#=============================================================
proc ROTSET { angle prev_angle dir kin_leader sys_leader } {
#=============================================================

#  This procedure will take an input angle and format for a specific machine.
#
#  angle	angle to be output.
#  prev_angle	previous angle out.  It should be mom_out_angle_pos
#  dir		can be either MAGNITUDE_DETERMINES_DIRECTION or
#		SIGN_DETERMINES_DIRECTION
#  kin_leader	leader (usually A, B or C) defined by postbuilder
#  sys_leader   leader that is created by rotset.  It could be C-.
#
  upvar $sys_leader lead

   while {$angle < 0.0} {set angle [expr $angle+360.0]}
   while {$angle >= 360.0} {set angle [expr $angle-360.0]}

   if {$dir == "MAGNITUDE_DETERMINES_DIRECTION"} {
      while {[expr abs([expr $angle-$prev_angle])] > 180.0} {
         if {[expr $angle-$prev_angle] < -180.0} {
            set angle [expr $angle+360.0]
         } elseif {[expr $angle-$prev_angle] > 180.0} {
            set angle [expr $angle-360.0]
         }
      }
   } elseif {$dir == "SIGN_DETERMINES_DIRECTION"} {
      set del [expr $angle-$prev_angle]
      if {($del < 0.0 && $del > -180.0) || $del > 180.0} {
         set lead "$kin_leader-"
      } else {
         set lead $kin_leader
      }
   }

return $angle
}


#=============================================================
proc ROTARY_AXIS_RETRACT {  } {
#=============================================================
#
#  This procedure is used by four and five axis posts to retract
#  from the part when the rotary axis become discontinuous.  This
#  procedure must be placed in the MOM_before_motion event.
#

   global mom_sys_rotary_error
   global mom_motion_event

   if {[info exists mom_sys_rotary_error] && [info exists mom_motion_event]} {
     if {$mom_sys_rotary_error != 0 && $mom_motion_event == "linear_move"} {

         global mom_kin_retract_plane mom_kin_reengage_distance
         global mom_kin_rotary_reengage_feedrate
         global mom_kin_rapid_feed_rate
         global mom_pos
         global mom_prev_pos
         global mom_prev_out_angle_pos
         global mom_kin_4th_axis_direction mom_kin_4th_axis_leader
         global mom_out_angle_pos mom_kin_5th_axis_direction mom_kin_5th_axis_leader
         global mom_kin_4th_axis_center_offset mom_kin_5th_axis_center_offset
         global mom_sys_leader mom_tool_axis mom_prev_tool_axis mom_kin_4th_axis_type
         global mom_kin_spindle_axis
         global mom_alt_pos mom_prev_alt_pos mom_feed_rate
         global mom_kin_rotary_reengage_feedrate
         global mom_feed_engage_value mom_feed_cut_value
         global mom_kin_4th_axis_limit_action mom_warning_info

         if {$mom_kin_4th_axis_limit_action == "Warning"} {
            set mom_warning_info  "Rotary axis limit violated, discontinuos motion may result"
            MOM_catch_warning
            unset mom_sys_rotary_error
            return
         }
         if {$mom_sys_rotary_error == "ROTARY CROSSING LIMIT." } {
            set roterr 0
         } else {
            set roterr 1
         }

        unset mom_sys_rotary_error

        # Retract from part

         VMOV 5 mom_pos save_pos
         VMOV 5 mom_prev_pos save_prev_pos
         VMOV 2 mom_out_angle_pos save_out_angle_pos
         set save_feedrate $mom_feed_rate

         global mom_sys_spindle_axis
         GET_SPINDLE_AXIS mom_prev_tool_axis

 	   global mom_kin_retract_type
 	   global mom_kin_retract_distance
         switch $mom_kin_retract_type {
             DISTANCE {
 		   set mom_pos(0) [expr $mom_prev_pos(0)+$mom_kin_retract_distance*$mom_sys_spindle_axis(0)]
 		   set mom_pos(1) [expr $mom_prev_pos(1)+$mom_kin_retract_distance*$mom_sys_spindle_axis(1)]
 		   set mom_pos(2) [expr $mom_prev_pos(2)+$mom_kin_retract_distance*$mom_sys_spindle_axis(2)]
               set num_sol 1
             }
             PLANE -
             default {
               set cen(0) 0.0
               set cen(1) 0.0
               set cen(2) 0.0
               if [info exists mom_kin_4th_axis_center_offset] {
                  VEC3_add cen mom_kin_4th_axis_center_offset cen
               }

               if {$mom_kin_4th_axis_type == "Table"} {
                  set num_sol [CALC_CYLINDRICAL_RETRACT_POINT mom_prev_pos mom_kin_spindle_axis $mom_kin_retract_plane ret_pt]
               } else {
                  set num_sol [CALC_SPHERICAL_RETRACT_POINT mom_prev_pos mom_prev_tool_axis cen $mom_kin_retract_plane ret_pt]
               }
               VEC3_add ret_pt cen mom_pos
             }
         }


         global mom_motion_distance
         global mom_feed_rate_number
         global mom_sys_frn_factor
         global mom_feed_retract_value
         global mom_feed_approach_value


         set dist [expr $mom_kin_reengage_distance*2.0]

         if {$num_sol != 0} {
        #
        # Retract from the part at rapid feed rate.  This is the same for both conditions.
        #
            MOM_suppress once fourth_axis fifth_axis
            set mom_feed_rate $mom_feed_retract_value
            if {[EQ_is_equal $mom_feed_rate 0.0]} {set mom_feed_rate $mom_kin_rapid_feed_rate}
            VEC3_sub mom_pos mom_prev_pos del_pos
            set dist [VEC3_mag del_pos]
            set mom_feed_rate_number [expr ($mom_sys_frn_factor*$mom_feed_rate)/ $dist]
            FEEDRATE_SET
            PB_CMD_linear_move
         } else {
	      set mom_warning_info "Retraction Plane or Sphere is defined inside of the current point.  No retraction will be output.  Reset the retraction plane to a greater value."
            MOM_catch_warning
         }


        #
        # temporary fix for missing mom_prev_out_angle_pos(0)
        #
         if {![info exists mom_prev_out_angle_pos(0)]} {
            set mom_prev_out_angle_pos(0) [MOM_ask_address_value fourth_axis]
         }
         if {![info exists mom_prev_out_angle_pos(1)]} {
            set mom_prev_out_angle_pos(1) [MOM_ask_address_value fifth_axis]
         }


         if {$roterr == 0} {
#
#  This section of code handles the case where a limit forces a reposition to an angle by adding or subtracting
#  360 until the new angle is within the limits.  This is either a four axis case or a five axis case where it is
#  not a problem with the inverse kinematics forcing a change of solution.  This is only a case of "unwinding"
#  the table.
#
           #
           # move to alternate rotary position
           #
            if {[info exists mom_kin_4th_axis_direction]} {
               set mom_out_angle_pos(0) [ROTSET $mom_prev_pos(3) $mom_out_angle_pos(0) $mom_kin_4th_axis_direction $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
            }
            if {[info exists mom_kin_5th_axis_direction]} {
               set mom_out_angle_pos(1) [ROTSET $mom_prev_pos(4) $mom_out_angle_pos(1) $mom_kin_5th_axis_direction $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)]
            }
            MOM_suppress once X Y Z
            MOM_do_template rapid_traverse

	     #
	     #  position back to part at approach feed rate
	     #
            GET_SPINDLE_AXIS mom_prev_tool_axis
            for {set i 0} {$i < 3} {incr i} {
               set mom_pos($i) [expr $mom_prev_pos($i)+$mom_kin_reengage_distance*$mom_sys_spindle_axis($i)]
            }
            MOM_suppress once fourth_axis fifth_axis
            set mom_feed_rate $mom_feed_approach_value
            if {[EQ_is_equal $mom_feed_rate 0.0]} {set mom_feed_rate $mom_kin_rapid_feed_rate}
            set dist [expr $dist-$mom_kin_reengage_distance]
            if {[EQ_is_zero $dist]} {set dist .0001}
            set mom_feed_rate_number [expr ($mom_sys_frn_factor*$mom_feed_rate) / $dist ]
            FEEDRATE_SET
            PB_CMD_linear_move

	     #
	     #  feed back to part at engage feed rate
	     #
            MOM_suppress once fourth_axis fifth_axis
            if {$mom_feed_engage_value  > 0.0} {
               set mom_feed_rate $mom_feed_engage_value
            } elseif {$mom_feed_cut_value  > 0.0} {
               set mom_feed_rate $mom_feed_cut_value
            } else {
               set mom_feed_rate 10.0
            }
            FEEDRATE_SET
            VEC3_sub mom_pos mom_prev_pos del_pos
            set mom_feed_rate_number [expr ($mom_sys_frn_factor*$mom_feed_rate) / $mom_kin_reengage_distance ]
            VMOV 3 mom_prev_pos mom_pos
            PB_CMD_linear_move

            VEC3_sub mom_pos save_pos del_pos
            set dist [VEC3_mag del_pos]
            set mom_feed_rate_number [expr ($mom_sys_frn_factor*$mom_feed_rate)/ $dist]
            FEEDRATE_SET

            VMOV 5 save_pos mom_pos
            VMOV 5 save_prev_pos mom_prev_pos
            VMOV 2 save_out_angle_pos mom_out_angle_pos
         } else {
#
#  This section of code handles the case where there are two solutions to the tool axis inverse kinematics.
#  The post is forced to change from one solution to the other.  This causes a discontinuity in the tool path.
#  The post needs to retract, rotate to the new rotaries, then position back to the part using the alternate
#  solution.
#
           #
           # move to alternate rotary position
           #
            if {![ANGLE_CHECK mom_prev_alt_pos(3) 4]} {
                set mom_out_angle_pos(0) [ROTSET $mom_prev_alt_pos(3) $mom_prev_out_angle_pos(0) $mom_kin_4th_axis_direction $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
            } else {
                set mom_out_angle_pos(0) $mom_prev_alt_pos(3)
            }
           if {![ANGLE_CHECK mom_prev_alt_pos(4) 5]} {
                set mom_out_angle_pos(1) [ROTSET $mom_prev_alt_pos(4) $mom_prev_out_angle_pos(1) $mom_kin_5th_axis_direction $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)]
            } else {
                set mom_out_angle_pos(1) $mom_prev_alt_pos(4)
            }
            set mom_pos(3) $mom_prev_alt_pos(3)
            set mom_pos(4) $mom_prev_alt_pos(4)
            set mom_prev_out_angle_pos(0) $mom_out_angle_pos(0)
            set mom_prev_out_angle_pos(1) $mom_out_angle_pos(1)
            VMOV 3 mom_prev_pos mom_pos
            MOM_suppress once X Y Z
            MOM_do_template rapid_traverse
	     #
	     #  position back to part at approach feed rate
	     #
            set mom_prev_pos(3) $mom_pos(3)
            set mom_prev_pos(4) $mom_pos(4)
            for {set i 0} {$i < 3} {incr i} {
               set mom_pos($i) [expr $mom_prev_alt_pos($i)+$mom_kin_reengage_distance*$mom_sys_spindle_axis($i)]
            }
            MOM_suppress once fourth_axis fifth_axis
            set mom_feed_rate $mom_feed_approach_value
            if {[EQ_is_equal $mom_feed_rate 0.0]} {set mom_feed_rate $mom_kin_rapid_feed_rate}
            set mom_feed_rate_number [expr ($mom_sys_frn_factor*$mom_feed_rate) / ($dist-$mom_kin_reengage_distance) ]
            FEEDRATE_SET
            PB_CMD_linear_move

	     #
	     #  feed back to part at engage feed rate
	     #
            MOM_suppress once fourth_axis fifth_axis
            if {$mom_feed_engage_value  > 0.0} {
               set mom_feed_rate $mom_feed_engage_value
            } elseif {$mom_feed_cut_value  > 0.0} {
               set mom_feed_rate $mom_feed_cut_value
            } else {
               set mom_feed_rate 10.0
            }
            VEC3_sub mom_pos mom_prev_alt_pos del_pos
            set mom_feed_rate_number [expr ($mom_sys_frn_factor*$mom_feed_rate) / $mom_kin_reengage_distance ]
            VMOV 3 mom_prev_alt_pos mom_pos
            FEEDRATE_SET
            PB_CMD_linear_move

            VEC3_sub mom_pos save_pos del_pos
            set dist [VEC3_mag del_pos]
            set mom_feed_rate_number [expr ($mom_sys_frn_factor*$mom_feed_rate)/ $dist]
            FEEDRATE_SET


            VMOV 5 save_pos mom_pos
            VMOV 5 save_prev_pos mom_prev_pos

            set mom_out_angle_pos(0) [ROTSET $mom_pos(3) $mom_prev_out_angle_pos(0) $mom_kin_4th_axis_direction $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
            set mom_out_angle_pos(1) [ROTSET $mom_pos(4) $mom_prev_out_angle_pos(1) $mom_kin_5th_axis_direction $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)]

            MOM_reload_variable -a mom_out_angle_pos
         }


         set save_feedrate $mom_feed_rate
         FEEDRATE_SET
      }
   }
}


#=============================================================
proc GET_SPINDLE_AXIS { input_tool_axis } {
#=============================================================

  upvar $input_tool_axis axis

  global mom_kin_4th_axis_type
  global mom_kin_4th_axis_plane
  global mom_kin_5th_axis_type
  global mom_kin_spindle_axis
  global mom_sys_spindle_axis
  MOM_output_literal "mom_kin_4th_axis_type $mom_kin_4th_axis_type mom_kin_4th_axis_plane $mom_kin_4th_axis_plane"
  MOM_output_literal "mom_kin_5th_axis_type $mom_kin_5th_axis_type mom_kin_spindle_axis $mom_kin_spindle_axis"
  MOM_output_literal "mom_sys_spindle_axis $mom_sys_spindle_axis"
  if {$mom_kin_4th_axis_type == "Table"} {
    VMOV 3 mom_kin_spindle_axis mom_sys_spindle_axis
  } elseif {$mom_kin_5th_axis_type == "Table"} {
    VMOV 3 axis vec
    if {$mom_kin_4th_axis_plane == "XY"} {
      set vec(2) 0.0
    } elseif {$mom_kin_4th_axis_plane == "ZX"} {
      set vec(1) 0.0
    } elseif {$mom_kin_4th_axis_plane == "YZ"} {
      set vec(0) 0.0
    }
    set l [VEC3_unitize vec mom_sys_spindle_axis]
    if {[EQ_is_zero l]} {set mom_sys_spindle_axis(2) 1.0}
  } else {
    VMOV 3 axis mom_sys_spindle_axis
  }
  MOM_output_literal "mom_sys_spindle_axis $mom_sys_spindle_axis"
}


#=============================================================
proc LIMIT_ANGLE { a } {
#=============================================================

   while {$a < 0.0} {set a [expr $a+360.0]}
   while {$a >= 360.0} {set a [expr $a-360.0]}

return $a
}
if [info exists mom_sys_start_of_program_flag] {
   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }
} else {
   set mom_sys_head_change_init_program 1
   set mom_sys_start_of_program_flag 1
}


